
' *************************************************************************************
' *************************************************************************************
' *** 
' *** Written by Wellington: Dec/2002 - Feb/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit

  Dim FactionFolder, Bifname, actionname, ShieldCnt, WeaponCnt, DicFile
  Dim ItemUnitName, MTWFilePathDic, Ref, AdjustedCP

  Set Ref = CreateObject(Image_Package)
 
  Call ProcessSelections()

  Set MTWFilePathDic = CreateObject("Scripting.Dictionary")
  
  Call BuildAllFilePaths("Output\MTWFiles\") 
  Call WritePathXref(MTWFilePathDic, "Ref_FileXref.txt", OMTWPath) 
 
  Set MTWFilePathDic = Nothing
  Set Ref = Nothing
 

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Process the selections 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ProcessSelections()
  Dim i, j, k, temp, temp2, Dickeys, Dicitems, dickey, dicitem, selkeys, key1, key2
  Dim createbifs 
  
  Selkeys = SelectionDic.Keys 
  For i = 0 To SelectionDic.Count -1   
    FactionFolder  = Selkeys(i)
    Call WriteSLMsg(0,"Processing faction """ & FactionFolder & """ ...") 
    
    If (FactionBifDic.Exists(FactionFolder)) Then
      createbifs = FactionBifDic.Item(FactionFolder)
      temp = Split(FactionBifDic.Item(FactionFolder), ",") 
      Call WriteSLMsg(0,"... determined BIFs (" & createbifs & ") for faction """ & FactionFolder & """ ...")       
      For j = 0 to Ubound(temp)       
        Dickeys  = DefineUnitsDic.Keys 
        Dicitems = DefineUnitsDic.Items
        Bifname = temp(j)
        key1 = Bifname & "," & FactionFolder 
        Call WriteSLMsg(0,"... using key (" & key1 & ") for faction """ & FactionFolder & """ ...")  
        UnitBifDic.RemoveAll  
        For k = 0 To DefineUnitsDic.Count -1   
          dickey  = Dickeys(k)
          dicitem = Dicitems(k)  
          temp2 = Split(dickey, ",")
          key2 = temp2(0) & "," & temp2(1)             
          If (key1 = key2) Then
            UnitBifDic.Add dickey, dicitem
          End If
        Next           
        Call ProcessAFaction()    
      Next      
    Else
      Call WriteErr(Error_FactionNotFound, FactionFolder) 
    End If       
  Next

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Process A faction and bifname 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ProcessAFaction()
  Dim i, j, temp, Dickeys, Dicitems, dickey, dicitem, oparms

  Call WriteSLMsg(0,"... processing BIF """ & bifname & """...") 

  BifDic.RemoveAll

  SortedBifDic.RemoveAll 
  ObjectDic.RemoveAll
  ObjectXrefDic.RemoveAll
  ObjectIRDic.RemoveAll  
  UnitDic.RemoveAll
  APDic.RemoveAll
  PositionDic.RemoveAll

  Call ReadDicXref()  

  Call BuildActionPages() 
  Call BuildBIFFolder()
  Call BuildItemsFolders()
  Call BuildPicturesFolders()

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Write all the Dic's into a single file - ready for the next stage 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

Sub ReadDicXref()
  Dim i, filename, temp, keyword, key, item

  CurrentFile = """DICXref.txt"""
  Call WriteSLMsg(0,"... reading ""DICXref_" & bifname & ".txt"" file ...") 

  filename = OFrmPath & factionfolder & "\DICXref_" & bifname & ".txt"        
 
  Call ReadTxtFile(filename)  
  
  For i = 0 to Ubound(TxtFileArray)-1 
    TxtFileArray(i) = TxtFileArray(i) + OneSpace   
    temp = Split(TxtFileArray(i), " ")
    keyword = temp(0)
    key = temp(1)
    item = temp(2)

    Select Case Lcase(keyword)
       Case Lcase("sortedbifdic")
         sortedbifdic.Add key, item
       Case Lcase("objdic")
         objectdic.Add key, item        
       Case Lcase("objxrefdic")
         objectxrefdic.Add key, item        
       Case Lcase("objirdic")
         objectirdic.Add key, Builditem(temp)                  
       Case Lcase("unitdic")
         unitdic.Add key, item        
       Case Lcase("apdic")
         apdic.Add key, Builditem(temp)        
       Case Lcase("positiondic")
         positiondic.Add key, item
       Case Else  
    End Select
   
  Next
 
End Sub


Function Builditem(inlist)
  Dim temparray(6)

  temparray(0) = inlist(2)
  temparray(1) = inlist(3)
  temparray(2) = inlist(4)
  temparray(3) = inlist(5)
  temparray(4) = inlist(6)
  temparray(5) = inlist(7)
 
  Builditem = Join(temparray, Onespace)

End Function


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build action pages
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildActionPages()
  Dim i, j, k, temp, createpath, acts, act, trueact, MyFile, filename
  Dim key, Dickeys, Dicitems, dickey, dicitem

  Call BuildAllFolders("Output\MTWFiles\Textures\Men", false)
  Call BuildAllFolders("Output\MTWFiles\Textures\Men\ActionsPage", false)

  Dickeys  = UnitDic.Keys 
  Dicitems = UnitDic.Items   
  For i = 0 To UnitDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
   
    Call WriteSLMsg(0,"... writing """ & dickey & ".txt"" file to ActionsPage...") 
    filename = OMTWPath & "Textures\Men\ActionsPage\" & dickey & ".txt"
    If (fso.FileExists(filename)) Then
      fso.DeleteFile(filename)
    End If
    Set MyFile = fso.OpenTextFile(filename, ForAppending, True)

    temp = Split(dicitem, ",")    
    For j = 0 To Ubound(temp) 
      acts = Split(temp(j), "/")
      act = acts(0)
      If (Right(act, 1) = "2" or Right(act, 1) = "3") Then
        trueact = Left(act, Len(act)-1) 
      Else
        trueact = act
      End If
      MyFile.Writeline trueact 

      For k = 1 To 4
        key = act & "_" & k 
        If (APDic.Exists(key)) Then  
          MyFile.Writeline APDic.Item(key)
        Else
          MyFile.Writeline "?"
        End If 
      Next       
    Next

    MyFile.Close 
    Set MyFile = Nothing  
    
  Next

End Sub

   
' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build BIF folder
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildBIFFolder()
  Dim i, temp, createpath, itemdata
  Dim j, Dickeys, Dicitems, dickey, dicitem, imagefile, objectfile, framepos
  
  Call BuildAllFolders("Output\MTWFiles", false)
  Call BuildAllFolders("Output\MTWFiles\Textures\Men\" & BifName, false)

  createpath = OMTWPath & "Textures\Men\" & BifName

  Call BuildLoresBIF(OFrmPath & FactionFolder, createpath)
  Call BuildHiresBIF(OFrmPath & FactionFolder, createpath)
  Call CheckAdjustBIF(OFrmPath & FactionFolder, createpath)
  Call InsertBIFpalette(OFrmPath & FactionFolder, createpath, Lores)
  Call InsertBIFpalette(OFrmPath & FactionFolder, createpath, Hires)
  Call BuildPaletteRefBIF(createpath, Bifname & "_H.bif")

  Call BuildObjectsFile(createpath, "Shields", "S", 5)
  Call BuildObjectsFile(createpath, "Weapons", "W", 8)
  Call BuildUnitObjectFiles(createpath)

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build the BIF files
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildLoresBIF(frompath, topath)
  Dim Myfile, MSDOSCommand, command, shell, FromBIF, toBIF

  Call WriteSLMsg(0,"... writing """ & bifname & ".bif"" file to """ & bifname & """ folder ...")

  If (fso.FileExists(topath & "\" & bifname & ".bif")) Then
    fso.DeleteFile(topath & "\" & bifname & ".bif")
  End If 
 
  FromBIF = GetShortPath(frompath) & "\" & bifname & "_f" 
  toBIF   = GetShortPath(topath) & "\" & bifname       
  command = "readbif.exe -i12"                  ' import 12 frames
  Set shell = createobject("wscript.shell")
  shell.currentdirectory = BRpath                   ' change directory    
  MSDOSCommand = command & " " & FromBIF & " " & toBIF  
  shell.Run MSDOScommand, 0, true          
  shell.currentdirectory = Rootpath                 ' restore directory   
End Sub


Sub BuildHiresBIF(frompath, topath)
  Dim Myfile, MSDOSCommand, command, shell, FromBIF, toBIF, f 

  Call WriteSLMsg(0,"... writing """ & bifname & "_H.bif"" file to """ & bifname & """ folder ...") 

  If (fso.FileExists(topath & "\" & bifname & "_H.bif")) Then
    fso.DeleteFile(topath & "\" & bifname & "_H.bif")
  End If
 
  FromBIF = GetShortPath(frompath) & "\" & bifname & "_H_f" 
  toBIF   = GetShortPath(topath) & "\" & bifname & "_H"    
  command = "readbif.exe -i"                  ' import 12 frames
  Set shell = createobject("wscript.shell")
  shell.currentdirectory = BRpath                   ' change directory    
  MSDOSCommand = command & " " & FromBIF & " " & toBIF  
  shell.Run MSDOScommand, 0, true          
  shell.currentdirectory = Rootpath                 ' restore directory 
End Sub

' returns the DOS short path name (for BifReader)

Function GetShortPath(filespec)    
  Set MyFile = fso.GetFolder(filespec)
  GetShortPath = MyFile.ShortPath 
End Function


' ******************************************************************************** 
' ********************************************************************************   
' *** 
' *** Check if we require to adjust the BIF Palette 
' ***
' ********************************************************************************  
' ******************************************************************************** 


Sub CheckAdjustBIF(frompath, topath)
  Dim BinBifCP, FromBIF, ToBIF, HexTable, filename, f, key, parms, AdjustRGB, ArrayRGB
  Dim i, temp, index, palette, num1, num2, amendcnt, amended, FromRGB, ToRGB 
  Dim aRGB1, aRGB2, aRGB3
  Dim AdjustR, fromR, toR, palR, fcR
  Dim AdjustG, fromG, toG, palG, fcG
  Dim AdjustB, fromB, toB, palB, fcB

  AdjustedCP = False
  
  key = FactionFolder & "," & Bifname
  If (AdjustBIFDic.Exists(key)) Then

    Call WriteSLMsg(0,"... adjusting BIF colour palette (" & bifname & ") ...") 
    parms = Split(AdjustBIFDic.Item(key),"/")
    AdjustRGB = parms(0)
    temp = Split(parms(0), ",")
    AdjustR = Cint(temp(0)) 
    AdjustG = Cint(temp(1))
    AdjustB = Cint(temp(2))
    temp = Split(parms(1), ",")
    fromR = Cint(temp(0)) 
    fromG = Cint(temp(1))
    fromB = Cint(temp(2))
    temp = Split(parms(2), ",")
    toR = Cint(temp(0)) 
    toG = Cint(temp(1))
    toB = Cint(temp(2))
    temp = Split(parms(3), ",")
    fcR = Cint(temp(0)) 
    fcG = Cint(temp(1))
    fcB = Cint(temp(2))

    filename = "Ref_" & bifname & "_ColourPalette.bin" 

    Call ExtractBIFColourPalette(frompath, filename)

    amendcnt = 0
    For index = 1 to 255 
      amended = False   
      ArrayRGB = DecRGB(PaletteArray(index))   
      temp = Split(ArrayRGB, ",")
 
      palR = Cint(temp(0))
      palG = Cint(temp(1))
      palB = Cint(temp(2)) 

      If (ArrayRGB <> "0,128,0") and (index <> 255) Then
        
        If (fcR >= 0 and fcR <= 255) Then
          If (CheckAdjustFC(palR, palG, palB, fcR, fcG, fcB)) Then
            If (ShowAdjustedRGBs) Then
              aRGB1 = DecRGB(PaletteArray(index)) & " - "
              aRGB2 = fcR & "," & fcG & "," & fcb & " - "
              aRGB3 = palR & "," & palG & "," & palB               
              Call WriteSLMsg(0,"... RGB FC adjusted - " & index & " - " & aRGB1 & aRGB2 & aRGB3 & " ...") 
              amended = True 
            End If
          End If 
        End If
      
        If (AdjustRGB <> "0,0,0") Then

          If (palR >= fromR and palR <= toR) Then
            If (palG >= fromG and palG <= toG) Then
              If (palB >= fromB and palB <= toB) Then 
                If (palR + AdjustR >= 0 and palR + AdjustR <= 255) Then 
                  palR = palR + AdjustR : amended = True 
                End If  
                If (palG + AdjustG >= 0 and palG + AdjustG <= 255) Then 
                  palG = palG + AdjustG : amended = True 
                End If 
                If (palB + AdjustB >= 0 and palB + AdjustB <= 255) Then
                  palB = palB + AdjustB : amended = True  
                End If             
              End If
            End If
          End If

        End If
      
      End If

      If (amended) Then
        amendcnt = amendcnt + 1
        If (ShowAdjustedRGBs) Then
          fromRGB = FormatRGB(temp(0), temp(1), temp(2))
          toRGB =   FormatRGB(palR, palG, palB)  
          Call WriteSLMsg(0,"... RGB adjusted from " & FromRGB & " to " & ToRGB & " ...") 
        End If
      End If

      PaletteArray(index) = RGB2Bif(palR & "," & palG & "," & palB)

    Next
    
    Call ReBuildBifPalette(frompath, filename)
    AdjustedCP = True
    Call WriteSLMsg(0,"... " & amendcnt & " RGBs adjusted in BIF colour palette (" & bifname & ") ...") 
  End If

End Sub



Function FormatRGB(R,G,B)
  Dim R1, G1, B1  
  R1 = Right("   " & R, 3)
  G1 = Right("   " & G, 3)
  B1 = Right("   " & B, 3)
  FormatRGB = "(" & R1 & "," & G1 & "," & B1 & ")"
End Function



Function CheckAdjustFC(R,G,B,Rscale,Gscale,Bscale)
  Dim temp, R1, G1, B1
  CheckAdjustFC = False
  R1 = R
  G1 = G
  B1 = B  
  If (G = 0) Then
    If ((R = B) and (R <> 0) and (R > 64)) Then  
      G1 = R         
      CheckAdjustFC = True
    End If
  Else
    If ((R = 0) and (B = 0) and (G > 64)) Then
      R1 = G  
      B1 = G 
      CheckAdjustFC = True
    End If 
  End If
  If (CheckAdjustFC) Then
    R = ScaleAColour(R1,Rscale)
    G = ScaleAColour(G1,Gscale)
    B = ScaleAColour(B1,Bscale)
  End If  
End Function



Function ScaleAColour(value, range)
  Dim square, modifier, result
  If (value > range) Then
    square = value - range  
  Else
    square = range - value
  End If 
  If (square <> 0) Then
    modifier = Cint(Sqr(square))
  Else
    modifier = 0
  End If
  If (value > range) Then
    result = range + modifier  
  Else
    result = range - modifier   
  End If
  If (result < 0) Then
    result = 0
  ElseIf (result > 255) Then
    result = 255
  End If 
  ScaleAColour = CInt(result) 
End Function



Sub ReBuildBifPalette(inpath, filename)
  Dim i, index, Hextable, BinBifCP, BinBmpCP, temp 
 
  Set HexTable = wscript.createobject("adodb.stream") 
  HexTable.open
  HexTable.type = 1
  HexTable.loadfromfile(DefBPath & "BinaryTable.bin")

  Set BinBmpCP = wscript.createobject("adodb.stream") 
  BinBmpCP.open
  BinBmpCP.type = 1 
  BinBmpCP.loadfromfile(inpath & "\" & filename)

  Set BinBifCP = wscript.createobject("adodb.stream") 
  BinBifCP.open
  BinBifCP.type = 1  

  BinBmpCP.CopyTo BinBifCP, 2
   
  For index = 1 to 255
    temp = Split(PaletteArray(index), ",")    
    HexTable.Position = temp(1)  
    HexTable.CopyTo BinBifCP, 1
    HexTable.Position = temp(0)  
    HexTable.CopyTo BinBifCP, 1 
  Next 
 
  BinBifCP.SetEOS
  BinBifCP.savetofile inpath & "\" &  "Ref_" & bifname & "_AdjustedColourPalette.bin", 2 

  WScript.DisconnectObject(HexTable) 
  WScript.DisconnectObject(BinBifCP)
  WScript.DisconnectObject(BinBmpCP)
    
End Sub          



' ******************************************************************************** 
' ********************************************************************************   
' *** 
' *** Insert BIF palette 
' ***
' ********************************************************************************  
' ******************************************************************************** 


Sub InsertBIFpalette(frompath, topath, filesuffix)
  Dim BinBifCP, FromBIF, ToBIF, HexTable, filename, f 

  If (AdjustedCP) Then
    filename = "Ref_" & bifname & "_AdjustedColourPalette.bin" 
  Else 
    filename = "Ref_" & bifname & "_ColourPalette.bin" 
  End If

  Call WriteSLMsg(0,"... replacing colour palette in """ & bifname & filesuffix & " ...") 

  If (fso.FileExists(topath & "\TempFile.bif")) Then
    fso.DeleteFile(topath & "\TempFile.bif")
  End If

  Set HexTable = wscript.createobject("adodb.stream") 
  HexTable.open
  HexTable.type = 1
  HexTable.loadfromfile(DefBPath & "BinaryTable.bin")

  Set BinBifCP = wscript.createobject("adodb.stream") 
  BinBifCP.open
  BinBifCP.type = 1
  BinBifCP.loadfromfile(frompath & "\" & filename)
  BinBifCP.Position = 0                                 
               
  Set FromBIF = wscript.createobject("adodb.stream") 
  FromBIF.open
  FromBIF.type = 1
  FromBIF.loadfromfile(topath & "\" & bifname & filesuffix) 
  FromBIF.Position = 512   

  Set ToBIF = wscript.createobject("adodb.stream")
  ToBIF.open
  ToBIF.type = 1
  ToBif.Position = 0 
   
  BinBifCP.CopyTo ToBIF                                
  
  ToBif.Position = 510
  HexTable.Position = 255  
  HexTable.CopyTo ToBif, 1
  HexTable.Position = 255  
  HexTable.CopyTo ToBif, 1   

  FromBIF.CopyTo ToBIF                              
   
  ToBIF.savetofile topath & "\TempFile.bif", 2        

  WScript.DisconnectObject(HexTable)
  WScript.DisconnectObject(BinBifCP)
  WScript.DisconnectObject(FromBIF)
  WScript.DisconnectObject(ToBIF)

  fso.DeleteFile(topath & "\" & bifname & filesuffix)  
  Set f = fso.GetFile(topath & "\TempFile.bif")
  f.Name = bifname & filesuffix

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build Objects files
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildObjectsFile(inpath, name, prefix, number)
  Dim i, MyFile, filename, count, key, temparray(9)

  count = 0
  For i = 1 to number
    key = prefix & i
    If (ObjectXrefDic.Exists(key)) Then
      temparray(i) = ObjectIRDic.Item(ObjectXrefDic.Item(key))
      count = count + 1
    Else
      temparray(i) = " "
    End If
  Next 

  If (count <> 0) Then
    Call WriteSLMsg(0,"... writing """ & name & ".txt"" file to """ & bifname & """ folder ...") 
    filename = inpath & "\" & name & ".txt"
    If (fso.FileExists(filename)) Then
      fso.DeleteFile(filename)
    End If
      
    Set MyFile = fso.OpenTextFile(filename, ForAppending, True)

    For i = 1 to number
      line = temparray(i)
      line = Replace(line, Dummy, OneSpace)
      line = Trim(line)
      line = Replace(line, OneSpace, ",") 
      MyFile.Writeline line
    Next
    MyFile.Close 
    Set MyFile = Nothing  
    
  End If

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build unit object files
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildUnitObjectFiles(inpath)
  Dim i, j, key, Dickeys, Dicitems, dickey, dicitem
  Dim MyFile, filename, line, temparray()

  Dickeys  = UnitDic.Keys 
  Dicitems = UnitDic.Items   
  For i = 0 To UnitDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)  

    If (CreateObjectArray(dicitem, line, "S", "shields")) Then
      line = Left(Line, Len(line)-1)
      Call WriteSLMsg(0,"... writing """ & dickey & "_S.txt"" file to """ & bifname & """ folder ...") 
      filename = inpath & "\" & dickey & "_S.txt"
      If (fso.FileExists(filename)) Then
        fso.DeleteFile(filename)
      End If      
      Set MyFile = fso.OpenTextFile(filename, ForAppending, True)
      MyFile.Writeline line    
      MyFile.Close 
      Set MyFile = Nothing  
    End If 

    If (CreateObjectArray(dicitem, line, "W", "weapons")) Then
      line = Left(Line, Len(line)-1)     
      Call WriteSLMsg(0,"... writing """ & dickey & "_W.txt"" file to """ & bifname & """ folder ...") 
      filename = inpath & "\" & dickey & "_W.txt"
      If (fso.FileExists(filename)) Then
        fso.DeleteFile(filename)
      End If      
      Set MyFile = fso.OpenTextFile(filename, ForAppending, True)
      MyFile.Writeline line    
      MyFile.Close 
      Set MyFile = Nothing  
    End If 
   
  Next

End Sub



Function CreateObjectArray(initems, instring, prefix, objname)
  Dim i, j, temp, temp2, parms, parms2, objlist, number, temparray(9)
  CreateObjectArray = False

  instring = ""
  temp = Split(initems, ",")
  For i = 0 to Ubound(temp)   
    temp2 = Split(temp(i), "/")
    If (Ubound(temp2) = 0) Then
      Call WriteSLMsg(0,"... no " & objname & " defined for action """ & temp2(0) & """ ...")      
    Else 
      parms = Split(PositionDic.Item(temp2(1)), ",") 
      For j = 0 to Ubound(parms)
        parms2 = Split(parms(j), "/")
        If (Left(parms2(0), 1) = prefix) Then
          number = Right(parms2(0), 1)
          If (temparray(number) = "") Then 
            instring = instring & number & ","
            temparray(number) = "X"
            CreateObjectArray = True
          End If
        End If  
      Next
    End If    
  Next

End Function


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build Items Folders
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildItemsFolders()
  Dim i, temp, temp2, createpath, itemdata
  Dim j, Dickeys, Dicitems, dickey, dicitem, imagefile, objectfile, framepos, firsttime 

  Call BuildAllFolders("Output\MTWFiles\Textures\Men\Items", false) 
  
  Dickeys  = UnitDic.Keys 
  Dicitems = UnitDic.Items   
  For i = 0 To UnitDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
    ItemUnitName = dickey
    temp = Split(dicitem, ",")
    firsttime = True 
    For j = 0 to Ubound(temp)
      temp2 = Split(temp(j), "/")
      If (Ubound(temp2) <> 0) Then 
        If (firsttime) Then 
          Call WriteSLMsg(0,"... building Shields/Weapons positioning files (Items) for " & ItemUnitName & " (""" & bifname & """) ...")     
          firsttime = False
        End If 
        Call CheckPositionDic(temp2(0), temp2(1))
      End If 
    Next   
  Next

End Sub



Sub CheckPositionDic(inaction, inposkey)
  Dim i, allitems, oneitem, temp, objectkey, objectfolder, objectfile, folderlist
  Dim fromfile, tofile, filename

  filename = MTWItemNamesDic.Item(inaction) & ".txt"
 
  allitems = PositionDic.Item(inposkey)
  oneitem  = Split(allitems, ",")   
  For i = 0 To Ubound(oneitem)  
    temp = Split(oneitem(i), "/")
    objectkey = temp(0)
    objectfolder = MTWItemsDic.Item(objectkey)
    objectfile = temp(1)

    folderlist = "Output\MTWFiles\Textures\Men\Items\" & objectfolder & "\" & ItemUnitName
    Call BuildAllFolders(folderlist, false)   
    
    tofile = RootPath & folderlist & "\" & filename  
    If (fso.FileExists(tofile)) Then
      fso.DeleteFile(tofile) 
    End If

    If (testmode) Then   
      Call WriteSLMsg(0,"... copying """ & filename & """ to folder ""Items\" & objectfolder & "\" & ItemUnitName & """ ...") 
    End If

    fromfile = IposPath & objectfile & ".txt"
    If (fso.FileExists(fromfile)) Then
      Call CopyAndRename(IposPath, folderlist & "\", objectfile & ".txt", filename)     
    Else
      If (Ucase(Left(objectkey, 1)) = "S") Then
        Call WriteWarn(Warning_ShieldPosFileNotFound, objectfile & ".txt") 
        Call CopyAndRename(DefPPath, folderlist & "\", "DummyShieldPositions.txt", filename)     
      Else
        Call WriteWarn(Warning_WeaponPosFileNotFound, objectfile & ".txt") 
        Call CopyAndRename(DefPPath, folderlist & "\", "DummyWeaponPositions.txt", filename)       
      End If 
    End If
     
  Next

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build Picture Folders
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildPicturesFolders() 
  Dim i, temp, j, Dickeys, Dicitems, dickey, dicitem, imagefile, objectfile, framepos
  
  Call BuildAllFolders("Output\MTWFiles\campmap\Info_Pics\Units", false)
  Call BuildAllFolders("Output\MTWFiles\campmap\review_panel\Units", false)
  Call BuildAllFolders("Output\MTWFiles\Battle\UnitIcons", false)  

  Dickeys  = UnitDic.Keys 
  Dicitems = UnitDic.Items   
  For i = 0 To UnitDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)

    If (Not PictureFileExists("IP", dickey)) Then
      Call WriteSLMsg(0,"... copying dummy ""info_pics"" file ("  & dickey & ".bif) ...") 
      Call CopyAndRename(DefIPath, "Output\MTWFiles\campmap\Info_Pics\Units\", "info_pics.bif", dickey & ".bif") 
    End If
  
    If (Not PictureFileExists("RP", dickey)) Then
      Call WriteSLMsg(0,"... copying dummy ""review_panel"" file (" & dickey & ".bif) ...") 
      Call CopyAndRename(DefIPath, "Output\MTWFiles\campmap\review_panel\Units\", "review_panel.bif", dickey & ".bif") 
    End If
  
    If (Not PictureFileExists("UI", dickey)) Then 
      Call WriteSLMsg(0,"... copying dummy ""uniticons"" file (" & dickey & ".lbm) ...")     
      Call CopyAndRename(DefIPath, "Output\MTWFiles\Battle\UnitIcons\", "uniticons.lbm", dickey & ".lbm")    
    End If

  Next

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Function PictureFileExists(picid, unitname)
  PictureFileExists = False
End Function


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub CopyAndRename(frompath, topath, oldname, newname)
  Dim f, filespec

  filespec = frompath & oldname 

  If (fso.FileExists(RootPath & topath & newname)) Then
    fso.DeleteFile RootPath & topath & newname
  End If
  
  fso.CopyFile filespec, RootPath & topath 
  Set f = fso.GetFile(RootPath & topath & oldname)
  f.Name = newname
 
End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build an array (FilePathArray) of all files in a root folder (and subfolders) 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

' ***
' *** Start the recursion
' ***

Sub BuildAllFilePaths(rootfolder)
  Dim fso, onefolder  
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set onefolder = fso.GetFolder(rootfolder)
  Call ShowFolderPaths(onefolder)  
End Sub

' ***
' *** Process folders
' ***

Sub ShowFolderPaths(onefolder)
  Dim folder
  For Each folder In onefolder.SubFolders
    Call ShowFilesPaths(folder)
    Call ShowFolderPaths(folder)
  Next
End Sub
 
' ***
' *** Process files
' ***

Sub ShowFilesPaths(folder)
  Dim file, i, filetype, pathfile, temp
  For Each file in folder.Files 
    pathfile = Right(file, Len(File) - Len(RootPath))
    MTWFilePathDic.Add pathfile, " "   
  Next
End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build palette ref
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

Sub BuildPaletteRefBIF(inpath, infile)
  Dim i, j, Wpos, Hpos, width, height, index, filename, temp 

  filename = "Ref_" & Bifname & "_BifColourPalette.bmp" 

  Call WriteSLMsg(0,"... writing Colour Palette reference  - """ & filename & """")

  Call ExtractBIFColourPalette(inpath, infile)

  Wpos = 20   
  Hpos = 16 
  width  = 40 + (16*Wpos)
  height = 40 + (16*Hpos)

  Ref.NewImage width, height, Colour_White 

  Ref.PenColor = "C0C0C0"
  Ref.PenThickness = 1
  Ref.PenStyle = 0 
  Ref.BrushColor = "C0C0C0"
  
  Ref.BrushStyle = 0
  Ref.TextBG    = Colour_White
  Ref.TextColor = Colour_Black 
  
  index = 0
  For i = 1 to 16
    For j = 1 to 16      
      Ref.BrushColor = PaletteArray(index)
      index = index + 1 
      Ref.Rectangle Wpos, Hpos, Wpos+20, Hpos+16   
      Wpos = Wpos + 20
    Next
    Wpos = 20    
    Hpos = Hpos + 16    
  Next 
 
  Ref.Writefile inpath & "\" & filename 

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Extract BIF Colour palette
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ExtractBIFColourPalette(inpath, infile)
  Dim i, ignore, palette, MyFile, n1, n2, H1, H2, index, numRGB   
 
  Set MyFile = fso.OpenTextFile(inpath & "\" & infile, 1, False, 0) 
 
  palette = MyFile.Read(512)  
  MyFile.Close
  Set MyFile = Nothing 

  index = 0
  For i = 1 to 512 step 2
    n1 = Cbyte(Asc(Mid(palette,i,1)))
    n2 = Cbyte(Asc(Mid(palette,i+1,1)))
    H1 = Right("0" & Hex(n1), 2)
    H2 = Right("0" & Hex(n2), 2) 
    numRGB = Bif2RGB(H1 & H2)   
    PaletteArray(index) = HexRGB(numRGB)
    index = index + 1
  Next 
  ' Call showarray(PaletteArray,"PaletteArray")  
End Sub



