

' *************************************************************************************
' *************************************************************************************
' *** 
' *** Written by Wellington: Dec/2002 - Feb/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit

  Dim PCXFilePathDic, FilePathCnt, MaxH, MaxW

  MaxH = 0
  MaxW = 0

  Set PCXFilePathDic = CreateObject("Scripting.Dictionary")
  
  Call BuildAllFilePaths(IPCXPath)
  Call WritePathXref(PCXFilePathDic, "Ref_FileXref.txt", IPCXPath) 

  Call ProcessDic()

  Set PCXFilePathDic = Nothing


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build an array (FilePathArray) of all files in a root folder (and subfolders) 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

' ***
' *** Start the recursion
' ***

Sub BuildAllFilePaths(rootfolder)
  Dim fso, onefolder
  Call WriteSLMsg(0,"... Building all file paths ...")  
  FilePathCnt = 0  
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set onefolder = fso.GetFolder(rootfolder)
  Call ShowFolderPaths(onefolder)  
End Sub

' ***
' *** Process folders
' ***

Sub ShowFolderPaths(onefolder)
  Dim folder, temp
  For Each folder In onefolder.SubFolders 
    temp = Right(folder, Len(folder) - Len(IPCXPath)) 
    temp = Split(temp, "\")
    If (SelectionDic.Exists(temp(0))) Then
      Call ShowFilesPaths(folder)
      Call ShowFolderPaths(folder)
    End If
  Next
End Sub
 
' ***
' *** Process files
' ***

Sub ShowFilesPaths(folder)
  Dim file, i, filetype, pathfile, temp
  For Each file in folder.Files 
    pathfile = Right(file, Len(File) - Len(IPCXPath))
    temp = Split(pathfile, "\")    
    PCXFilePathDic.Add pathfile, temp(0) & "\" & temp(1)      
    FilePathCnt = FilePathCnt + 1    
  Next
End Sub



' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build an array (FilePathArray) of all files in a root folder (and subfolders) 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

' ***
' *** Process the dictionary
' ***

Sub ProcessDic()
  Dim foldername, filename, mf, f1, nf, mfsf, lastpath, createpath, topath
  Dim faction, percent
  Dim i, temp, Dickeys, Dicitems, dickey, dicitem, H, W 
  Call WriteSLMsg(0,"... Processing all folders ...")

  Call BuildAllFolders("Output\UnitBMPs", false)

  Set Source = CreateObject(Image_Package)  

  Dickeys  = PCXFilePathDic.Keys 
  Dicitems = PCXFilePathDic.Items   
  For i = 0 To PCXFilePathDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
    temp = Split(dickey, "\")
    faction = Lcase(temp(0)) 
    filename = temp(2)
    temp = Split(dicitem, "\") 
    If (dicitem <> lastpath) Then 
      Call BuildAllFolders("Output\UnitBMPs\" & temp(0), false)
      Call BuildAllFolders("Output\UnitBMPs\" & temp(0) & "\" & temp(1), false)
      Call WriteSLMsg(0,"... processing folder - """ & temp(0) & "\" & temp(1) & """ ...")     
    End If 

    If (Lcase(Right(filename,4)) <> ".pcx") Then
      Set f1 = fso.GetFile(IPCXpath & dickey)
      Call WriteSLMsg(0,"... adding "".pcx"" extension to " & filename & " ...")
      f1.Name = filename & ".pcx" 
      dickey = dickey & ".pcx"   
    End If  

    Source.Readfile IPCXpath & dickey   
    topath = Left(OBMPpath & dickey, Len(OBMPpath & dickey) -4) 
    Source.ColorDepth = 8    
    If (ResizeDic.Exists(faction)) Then
      percent = ResizeDic.Item(faction)
      Source.Scale percent
      If (dicitem <> lastpath) Then 
        Call WriteSLMsg(0,"... resizing all images by " & percent & "% ...") 
      End If
    End If

    Source.Writefile topath & ".bmp"
    If (Source.Height > MaxH) Then
      MaxH = Source.Height
    End If
    If (Source.Width > MaxW) Then
      MaxW = Source.Width
    End If
    lastpath = dicitem 
  Next 

  Set Source = Nothing  
  
End Sub

 