
' *************************************************************************************
' *************************************************************************************
' *** 
' *** Written by Wellington: Dec/2002 - Feb/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit

  Dim FactionFolder, Bifname, actionname, ShieldCnt, WeaponCnt, Ref, DicFile, TempResizeDic
  Dim oldBGpos
 
  Set Ref = CreateObject(Image_Package)
  Set TempResizeDic = CreateObject("Scripting.Dictionary") 

  Call ProcessSelections()

  Set Ref = Nothing 
  Set TempResizeDic = Nothing
  

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Process the selections 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ProcessSelections()
  Dim i, j, k, temp, temp2, Dickeys, Dicitems, dickey, dicitem, selkeys, key1, key2 
  Dim createbifs

  Call BuildAllFolders("Output\UnitFrames", false)

  Selkeys = SelectionDic.Keys 
  For i = 0 To SelectionDic.Count -1   
    FactionFolder  = Selkeys(i)
    Call WriteSLMsg(0,"Processing faction """ & FactionFolder & """ ...") 
    Call ReadHWXref(FactionFolder)
    If (testmode) Then
      Call WriteDic(FactionBifDic, "FactionBifDic")
      Call WriteDic(DefineUnitsDic, "DefineUnitsDic")
    End If
    If (FactionBifDic.Exists(FactionFolder)) Then
      createbifs = FactionBifDic.Item(FactionFolder)
      temp = Split(createbifs, ",") 
      Call WriteSLMsg(0,"... determined BIFs (" & createbifs & ") for faction """ & FactionFolder & """ ...")       
      For j = 0 to Ubound(temp)       
        Dickeys  = DefineUnitsDic.Keys 
        Dicitems = DefineUnitsDic.Items
        Bifname = temp(j)
        key1 = Bifname & "," & FactionFolder 
        Call WriteSLMsg(0,"... using key (" & key1 & ") for faction """ & FactionFolder & """ ...")       
        UnitBifDic.RemoveAll  
        For k = 0 To DefineUnitsDic.Count -1   
          dickey  = Dickeys(k)
          dicitem = Dicitems(k)  
          temp2 = Split(dickey, ",")
          key2 = temp2(0) & "," & temp2(1)         
          If (key1 = key2) Then
            If (UnitBifDic.Exists(dickey)) Then
              Call WriteErr(Error_DuplicateDicKey, "UnitBifDic/" & dickey)      
            Else
              UnitBifDic.Add dickey, dicitem
            End If
          End If
        Next           
        Call ProcessAFaction() 
        Call WriteDicXref()     
      Next  
    Else
      Call WriteErr(Error_FactionNotFound, FactionFolder) 
    End If      
  Next

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Process A faction and bifname 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ProcessAFaction()
  Dim i, j, temp, Dickeys, Dicitems, dickey, dicitem, oparms

  Call WriteSLMsg(0,"... processing BIF """ & bifname & """...") 

  BifDic.RemoveAll

  SortedBifDic.RemoveAll 
  ObjectDic.RemoveAll
  ObjectXrefDic.RemoveAll
  ObjectIRDic.RemoveAll  
  UnitDic.RemoveAll
  APDic.RemoveAll
  PositionDic.RemoveAll
 
  ShieldCnt = 0
  WeaponCnt = 0 
  
  Dickeys  = UnitBifDic.Keys 
  Dicitems = UnitBifDic.Items   
  For j = 0 To UnitBifDic.Count -1   
    dickey  = Dickeys(j)
    dicitem = Dicitems(j)  
    temp = Split(dickey, ",")    

    Select Case Lcase(temp(2))

      Case "action"           
        actionname = Lcase(temp(3))
        Call GetNext4CA(Lcase(FactionFolder & "\" & dicitem)) 
         
      Case "object"            
        oparms = Split(dicitem, ",") 
        If (Not ObjectDic.Exists(oparms(0))) Then
          If (Ubound(oparms) = 0) Then 
            ObjectDic.Add  oparms(0), Dummy & "," & Dummy  
            ShieldCnt = ShieldCnt + 1
          ElseIf (Ubound(oparms) = 2) Then 
            ObjectDic.Add  oparms(0), oparms(1) & "," & oparms(2)
            WeaponCnt = WeaponCnt + 1 
          ElseIf (Ubound(oparms) = 4) Then 
            ObjectDic.Add  oparms(0), oparms(1) & "," & oparms(2) & "," & oparms(3) & "," & oparms(4)
            WeaponCnt = WeaponCnt + 1 
          End If
          ObjectXrefDic.Add Ucase(temp(3)), oparms(0)
        End If
      
      Case "position"            
        oparms = Split(dicitem, ",") 
        If (Not PositionDic.Exists(temp(3))) Then          
          PositionDic.Add temp(3), dicitem
        End If
       
      Case "unitname"           
        oparms = Split(dicitem, ",") 
        If (UnitDic.Exists(temp(3))) Then
          Call WriteErr(Error_DuplicateDicKey, "UnitDic/" & temp(3))      
        Else             
          UnitDic.Add temp(3), dicitem               
        End If   
      Case Else
    End Select 
    
  Next 

  Call SortBifDic()                
  Call BuildFrames()
  Call BuildAPDic() 

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Write all the Dic's into a single file - ready for the next stage 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

  
Sub WriteDicXref()
  Dim filename

  CurrentFile = """DICXref_" & bifname & ".txt"""
  Call WriteSLMsg(0,"... writing ""DICXref_" & bifname & ".txt"" file ...") 

  filename = OFrmPath & factionfolder & "\DICXref_" & bifname & ".txt"    
  If (fso.FileExists(filename)) Then
    fso.DeleteFile(filename)
  End If
  Set DicFile = fso.OpenTextFile(filename, ForAppending, True)

  Call WriteADIC(sortedbifdic,"sortedbifdic")  
  Call WriteADIC(objectdic,"objdic")
  Call WriteADIC(objectxrefdic,"objxrefdic")
  Call WriteADIC(objectirdic,"objirdic") 
  Call WriteADIC(unitdic,"unitdic") 
  Call WriteADIC(apdic,"apdic") 
  Call WriteADIC(positiondic,"positiondic")
  Call WriteADIC(unitbifdic,"unitbifdic")

  DicFile.Close 
  Set DicFile = Nothing  

End Sub



Sub WriteADIC(dicobject, dicname) 
  Dim i, Dickeys, Dicitems, dickey, dicitem, line  

  Dickeys  = dicobject.Keys 
  Dicitems = dicobject.Items   
  For i = 0 To dicobject.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
    line = dicname & " " & vbtab & dickey & "  " & dicitem     
    DicFile.Writeline line
  Next
  DicFile.Writeline " "

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Read the Height/Width Xref for this faction 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ReadHWXref(inpath)
  Dim i, faction, filepath, temp, parms, parmlist, keywords 
  CurrentFile = """HWXref.txt""" 

  filepath = OImgPath & inpath & "\HWXref.txt" 
  Call WriteSLMsg(0,"... Reading " & inpath & " ""HWXref.txt"" parameters ...") 
  Call ReadTxtFile(filepath)  
 
End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Add the next 4 camera angles into BifDic
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub GetNext4CA(reqfolders)
  Dim i, temp, temp2, folders, j
 
  j = 1
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), "\") 
    folders = Lcase(temp(0) & "\" & temp(1))
    If (folders = reqfolders) Then
      temp2 = Split(temp(2), " ") 
      folders = folders & "\" & temp2(0)
      If (BifDic.Exists(folders)) Then
        Call WriteErr(Error_DuplicateDicKey, "BifDic/" & folders)      
      Else  
        BifDic.Add folders, actionname & "," & temp2(1)
      End If 
      j = j + 1
    End If    
  Next

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build frames -  this is the MAIN processing routine in this program 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildFrames()
  Dim i, temp, Wpos, Hpos, maxW, maxH, Wsource, Hsource, frame, createpath, itemdata
  Dim j, Dickeys, Dicitems, dickey, dicitem, imagefile, objectfile, framepos
  Dim Image, Source, NewWH

  Call BuildAllFolders("Output\UnitFrames\" & FactionFolder, false)

  Call WriteSLMsg(0,"... building frames for BIF """ & Bifname & """  ...") 

  Set Image = CreateObject(Image_Package) 
  Set Source = CreateObject(Image_Package)

  Image.NewImage 512*12, 512, "008000" 
'  Image.ColorDepth = 8                    ' *** NOTE - Im not 100% sure about this yet ***

  Ref.NewImage 512, 512, "008000" 
  Ref.PenThickness = 1
  Ref.PenStyle = 0
  Ref.BrushStyle = 1 
  Ref.PenColor = "FFFFFF"
  Ref.BrushColor = "FFFFFF"

  Call BuildTempResizeDic()
  Call BuildObjects()  

' ***
' *** Build the master frame with all the figure images in  
' *** (Note: we build a master to ensure all 12 frames have a common colour palette)
' ***
  
  For frame = 1 to 12
    Call WriteSLMsg(0,"... adding figure images to frame " & frame & " (""" & Bifname & """) ...")
    maxW = 0
    maxH = 0
    Wpos = 0
    Hpos = 0
    framepos = (frame-1) * 512 
    Dickeys  = SortedBifDic.Keys 
    Dicitems = SortedBifDic.Items   
    For j = 0 To SortedBifDic.Count -1      
      dickey  = Dickeys(j)
      dicitem = Dicitems(j)
      temp = Split(dicitem, ",")          
      Hsource = temp(2)
      Wsource = temp(1) 
      Imagefile = OImgPath & dickey & "_" & frame & ".bmp"  
      If (TempResizeDic.Exists(dickey)) Then
        NewWH = Split(TempResizeDic.Item(dickey), ",")
        Wsource = NewWH(0) 
        Hsource = NewWH(1)
        Source.Resize Wsource, Hsource
      End If       
      If (Wpos + Wsource + 2 > 511) Then        
        Wpos = 0
        Hpos = Hpos + maxH + 2
        Image.MergeBack Imagefile, Wpos+1+framepos, Hpos+1 
        If (frame = 1) Then 
          Ref.MergeBack Imagefile, Wpos+1+framepos, Hpos+1           
          Ref.Rectangle Wpos+framepos, Hpos, Wpos+Wsource+2+framepos, Hpos+Hsource+2
        End If
        If (frame = 1) Then 
          itemdata = dicitem & "," & Wpos+1 & "," & Hpos+1              
          SortedBifDic.Item(dickey) = itemdata       
        End If
        Wpos = Wpos + Wsource + 2 
        maxH = Hsource
      Else 
        Image.MergeBack Imagefile, Wpos+1+framepos, Hpos+1
        If (frame = 1) Then 
          Ref.MergeBack Imagefile, Wpos+1+framepos, Hpos+1        
          Ref.Rectangle Wpos+framepos, Hpos, Wpos+Wsource+2+framepos, Hpos+Hsource+2
        End If
        If (frame = 1) Then 
          itemdata = dicitem & "," & Wpos+1 & "," & Hpos+1              
          SortedBifDic.Item(dickey) = itemdata  
        End If     
        Wpos = Wpos + Wsource + 2 
        If (Hsource > maxH) Then
          maxH = Hsource
        End If 
      End If      
    Next

' ***
' *** Add the objects (1st shields then weapons) to the master frame   
' ***

    Call WriteSLMsg(0,"... adding weapons/shields to frame " & frame & " (""" & Bifname & """) ...")

    Dickeys  = ObjectDic.Keys 
    Dicitems = ObjectDic.Items   
    For j = 0 To ObjectDic.Count -1   
      dickey  = Dickeys(j)
      dicitem = Dicitems(j)
      ObjectFile = OObjPath & dickey & ".bmp"    
      Source.Readfile ObjectFile
      Hsource = Source.height
      Wsource = Source.width
      temp = Split(dicitem, ",")
      If (Ubound(temp) = 3) Then
        Image.MergeBackBin Source.BMPData, "bmp", temp(2)+1+framepos, temp(3)+1
        Call AddObjectIR(dickey, Wsource, Hsource, temp(2), temp(3), temp(0), temp(1)) 
        If (frame = 1) Then  
          Ref.MergeBackBin Source.BMPData, "bmp", temp(2)+1+framepos, temp(3)+1       
          Ref.Rectangle temp(2)+framepos, temp(3), temp(2)+Wsource+2+framepos, temp(3)+Hsource+2
        End If
      Else 
        If (Wpos + Wsource + 2 > 511) Then        
          Wpos = 0
          Hpos = Hpos + maxH + 2
          Image.MergeBackBin Source.BMPData, "bmp", Wpos+1+framepos, Hpos+1 
          Call AddObjectIR(dickey, Wsource, Hsource, Wpos+1, Hpos+1, temp(0), temp(1)) 
          If (frame = 1) Then           
            Ref.MergeBackBin Source.BMPData, "bmp", Wpos+1+framepos, Hpos+1   
            Ref.Rectangle Wpos+framepos, Hpos, Wpos+Wsource+2+framepos, Hpos+Hsource+2
          End If
          Wpos = Wpos + Wsource + 2 
          maxH = Hsource
        Else 
          Image.MergeBackBin Source.BMPData, "bmp", Wpos+1+framepos, Hpos+1
          Call AddObjectIR(dickey, Wsource, Hsource, Wpos+1, Hpos+1, temp(0), temp(1)) 
          If (frame = 1) Then 
            Ref.MergeBackBin Source.BMPData, "bmp", Wpos+1+framepos, Hpos+1            
            Ref.Rectangle Wpos+framepos, Hpos, Wpos+Wsource+2+framepos, Hpos+Hsource+2
          End If
          Wpos = Wpos + Wsource + 2 
          If (Hsource > maxH) Then
            maxH = Hsource
          End If 
        End If 
      End If      
    Next 
 
  Next

' ***
' *** Now the tricky stuff! 1st write the ref frame (showing image rectangles) and the master    
' *** (as a 8 bit palette), then change the master (in memory) to 24 bit - no palette
' ***  

  Ref.ColorDepth = 8
  Call WriteSLMsg(0,"... writing Image Rectangles reference - ""Ref_" & Bifname & "_H.bmp""")
  Ref.Writefile OFrmPath & FactionFolder & "\Ref_" & Bifname & "_H.bmp"

  Image.ColorDepth = 8
  Call WriteSLMsg(0,"... writing master frame - ""Master_" & Bifname & "_H.bmp""")
  Image.Writefile OFrmPath & FactionFolder & "\Master_" & Bifname & "_H.bmp"
  Image.ColorDepth = 24
  Image.Writefile OFrmPath & FactionFolder & "\Master24_" & Bifname & "_H.bmp"

' ***
' *** Now extract the colour palette from the 8-bit master, read it in (just a one pixel bmp)    
' ***  and resize it to the same size as the master
' ***

  Call BuildGoodBMPPalette(OFrmPath & FactionFolder, "Master_" & Bifname & "_H.bmp")
 ' Call CheckBody()
 
  Source.Readfile OFrmPath & FactionFolder & "\GoodBMPPalette.bmp"
  Source.ColorDepth = 8
  Source.Resize Image.Width, Image.height  

' ***
' *** Now merge our 24 bit master with our new (good) source that now contains a good colour
' *** palette extract and write it out as the new master)      
' ***
  
  Call WriteSLMsg(0,"... merging new palette with master frame (""" & Bifname & """) ...")
'  msgbox source.height
'  msgbox source.width
'  msgbox image.height
'  msgbox image.width

  Source.MergeBackBin Image.BMPData, "bmp", 0, 0 
  Source.MergeBack "\Master24_" & Bifname & "_H.bmp", 0, 0 
  Source.Writefile OFrmPath & FactionFolder & "\NewMaster_" & Bifname & "_H.bmp"

' ***
' *** Write out 2 ref files for the 2 palettes in our 2 masters, and create a BIF colour
' *** palette (a 512 byte binary file) based on our new masters colour palette       
' ***
 
  Call BuildPaletteRefBMP(OFrmPath & FactionFolder, "Master_" & Bifname & "_H.bmp")
  Call BuildPaletteRefBMP(OFrmPath & FactionFolder, "NewMaster_" & Bifname & "_H.bmp")

  Call BuildPaletteBifBIN(OFrmPath & FactionFolder, "NewMaster_" & Bifname & "_H.bmp") ' "PaletteBMP.bmp")

' ***
' *** Now write out each frame from our new master    
' ***

  For frame = 1 to 12 
    Call WriteSLMsg(0,"... writing HiRes/Lores frames - """ & Bifname & "_H_f" & frame & ".bmp""")   
    framepos = (frame-1) * 512 
    Image.ReadStream "bmp", Source.BMPData 
    Image.Crop framepos, 0, framepos+512, 512
    Image.Writefile OFrmPath & FactionFolder & "\" & Bifname & "_H_f" & frame & ".bmp"
    Image.Resize 256, 256   
    Image.Writefile OFrmPath & FactionFolder & "\" & Bifname & "_f" & frame & ".bmp" 
  Next

  Set Image = Nothing 
  Set Source = Nothing

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Rebuild the objects to ensure the smallest image rectangle size
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

 
Sub BuildObjects()
  Dim i, temp, Dickeys, Dicitems, dickey, dicitem

  Call WriteSLMsg(0,"... checking weapons/shields image rectangles "  & " (""" & Bifname & """) ...")

  Call BuildAllFolders("Output\ObjectImages\", false)

  Dickeys  = ObjectDic.Keys 
  Dicitems = ObjectDic.Items   
  For i = 0 To ObjectDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
    If (fso.FileExists(OObjPath & dickey & ".bmp")) Then
      fso.DeleteFile OObjPath & dickey & ".bmp"
    End If  
    fso.CopyFile IObjPath & dickey & ".bmp", OObjPath  
  Next

End Sub 

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Add the 4 co-ordinates into the object image rectangle dictionary (ObjectIRDic)
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

 
Sub AddObjectIR(key, W, H, Wpos, Hpos, P1, P2)
  Dim temp, item, x1, y1, x2, y2
  If (Not ObjectIRDic.Exists(key)) Then
    x1 = Cint(W / 2) 
    y1 = Cint(H / 2)
    x2 = Cint((W + Wpos) / 2)
    y2 = Cint((H + Hpos) / 2)   
    item = x1 & " " & y1 & " " & x2 & " " & y2 & " " & P1 & " " & P2 
    If (ObjectIRDic.Exists(key)) Then
      Call WriteErr(Error_DuplicateDicKey, "ObjectIRDic/" & key)      
    Else    
      ObjectIRDic.Add key, item
    End If
  End If

End Sub 

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Check if BMP resizing is required
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildTempResizeDic()
  Dim i, j, temp, Dickeys, Dicitems, dickey, dicitem, perc, HW, Wperc, Hperc  
  Dim key1, key2, WeWillResize

  TempDic.RemoveAll
  WeWillResize = False

  Dickeys  = SortedBifDic.Keys 
  Dicitems = SortedBifDic.Items   
  For j = 0 To SortedBifDic.Count -1   
    dickey  = Dickeys(j)
    dicitem = Dicitems(j)
    temp = Split(dickey, "\")
    key1 = temp(0) & "," & temp(1)
    key2 = temp(0) & ",*"
    If (ResizeActionDic.Exists(key1)) Then
      HW = Split(dicitem, ",")
      Perc = Split(ResizeActionDic.Item(key1), ",")
      Wperc = Cint((HW(1) * Perc(0)) / 100)
      Hperc = Cint((HW(2) * Perc(1)) / 100)
      TempResizeDic.Add temp(0) & "\" & temp(1) & "\" & temp(2), Wperc & "," & Hperc 
      WeWillResize = True      
    ElseIf (ResizeActionDic.Exists(key2)) Then
      HW = Split(dicitem, ",")
      Perc = Split(ResizeActionDic.Item(key2), ",")
      Wperc = Cint((HW(1) * Perc(0)) / 100)
      Hperc = Cint((HW(2) * Perc(1)) / 100)
      TempResizeDic.Add temp(0) & "\" & temp(1) & "\" & temp(2), Wperc & "," & Hperc
      WeWillResize = True    
    End If
  Next

  If (WeWillResize) Then
    Call WriteSLMsg(0,"... resizing will be performed at BMP level (""" & Bifname & """) ...")
  End If

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Check body of master
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

Sub CheckBody()
  Dim Body, count, found, found2, value, temparray(256), ascpos 

  Call WriteSLMsg(0,"... starting check-body ...")

  Body = SaveString(OFrmPath & FactionFolder, "Master_" & Bifname & "_H.bmp")
 
  found = 0
  For count = 1 To len(Body)
    value = Cbyte(Asc(Mid(Body,Count,1)))  
    If (value = oldBGpos) Then
      found = found + 1
   '   Mid(Body,Count,1) = Ascpos
    End If
    If (value = 0) Then
      found2 = found2 + 1
   '   Mid(Body,Count,1) = Ascpos
    End If
    temparray(value) = temparray(value) + 1
  Next

  Call WriteSLMsg(0,"... finished check-body ...")
  wscript.echo len(Body),vbcrlf,oldbgpos,vbcrlf,found,vbcrlf,found2
  call showarray256(temparray,"temparray")
End Sub



Function SaveString(inpath, infile) 
  Dim MyFile, ignore

  Set MyFile = fso.OpenTextFile(inpath & "\" & infile, 1, False, 0) 
  ignore = MyFile.Read(54)
  ignore = MyFile.Read(256*4)
  SaveString = MyFile.Read(512*512*12)  
  MyFile.Close
  Set MyFile = Nothing 
End Function
 

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build good BMP pallette
' *** 
' ****************************************************************************** 
' ****************************************************************************** 
   

Sub BuildGoodBMPPalette(inpath, infile)
  Dim i, j, Wpos, Hpos, width, height, index, filename, temp, first128
  Dim Hextable, ToBMP, FromBMP   

  filename = "GoodBMPPalette.bmp" 

  Call ExtractBMPColourPalette(inpath, infile, false) 

  first128 = True
  If (PaletteArray(0) <> "008000") Then
    For i = 1 to 254
      If (PaletteArray(i) = "008000") Then
        If (first128) Then
          first128 = False 
          PaletteArray(i) = PaletteArray(0)
          PaletteArray(0) = "008000"
          Call WriteSLMsg(0,"... swopped palette entries in """ & infile & """ at positions 0/" & i & " ...") 
        Else
          PaletteArray(i) = "FFFFFF"          
          Call WriteSLMsg(0,"... replaced subsequent palette entry (0,128,0) with (0,0,0) at position" & i & " ...")  
        End If     
      End If
    Next  
  End If

  Set HexTable = wscript.createobject("adodb.stream") 
  HexTable.open
  HexTable.type = 1
  HexTable.loadfromfile(DefBPath & "BinaryTable.bin")

  Set FromBMP = wscript.createobject("adodb.stream") 
  FromBMP.open
  FromBMP.type = 1 
  FromBMP.loadfromfile(DefBPath & "OnePixel.bin")
 
  Set ToBMP = wscript.createobject("adodb.stream") 
  ToBMP.open
  ToBMP.type = 1  

  FromBMP.CopyTo ToBMP, 58  

  For i = 1 to 254  
    temp = DecRGB(PaletteArray(i)) 
    temp = Split(temp, ",")  
    HexTable.Position = temp(2)  
    HexTable.CopyTo ToBMP, 1
    HexTable.Position = temp(1)  
    HexTable.CopyTo ToBMP, 1 
    HexTable.Position = temp(0)  
    HexTable.CopyTo ToBMP, 1 
    HexTable.Position = 0  
    HexTable.CopyTo ToBMP, 1 
  Next 
  
  FromBMP.Position = 54+(255*4)
  FromBMP.CopyTo ToBMP
 
  ToBMP.SetEOS
  ToBMP.savetofile inpath & "\GoodBMPPalette.bmp", 2 

  WScript.DisconnectObject(HexTable) 
  WScript.DisconnectObject(ToBMP)
  WScript.DisconnectObject(FromBMP)
    
End Sub          
         


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build palette ref
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildPaletteRefBMP(inpath, infile)
  Dim i, j, Wpos, Hpos, width, height, index, filename, temp 

  filename = "Ref_" & infile 

  Call WriteSLMsg(0,"... writing Colour Palette reference  - """ & filename & """")

  Call ExtractBMPColourPalette(inpath, infile, true)

  Wpos = 20   
  Hpos = 16 
  width  = 40 + (16*Wpos)
  height = 40 + (16*Hpos)

  Ref.PenColor = "808080"
  Ref.BrushColor = "808080"

  Ref.ColorDepth = 24 
  Ref.NewImage width, height, Colour_White 
  Ref.BrushStyle = 0
  Ref.TextBG    = Colour_White
  Ref.TextColor = Colour_Black 
  
  index = 0
  For i = 1 to 16
    For j = 1 to 16      
      Ref.BrushColor = PaletteArray(index)
      index = index + 1 
      Ref.Rectangle Wpos, Hpos, Wpos+21, Hpos+17   
      Wpos = Wpos + 20
    Next
    Wpos = 20    
    Hpos = Hpos + 16    
  Next 
 
  Ref.Writefile inpath & "\" & filename 

End Sub

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Extract BMP Colour palette
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub ExtractBMPColourPalette(inpath, infile, writemsg)
  Dim i, j, ignore, palette, MyFile, R, G, B, RGB, index   
 
  Set MyFile = fso.OpenTextFile(inpath & "\" & infile, 1, False, 0) 
  ignore = MyFile.Read(54)
  palette = MyFile.Read(256*4)  
  MyFile.Close
  Set MyFile = Nothing 

  index = 0
  For i = 1 to 256*4 step 4
    B = Cbyte(Asc(Mid(palette,i,1)))
    G = Cbyte(Asc(Mid(palette,i+1,1)))
    R = Cbyte(Asc(Mid(palette,i+2,1)))
  '  If (writemsg) Then
      If (R = 0 and G = 128 and B = 0) Then       
        Call WriteSLMsg(0,"... position of RGB(0,128,0) in """ & infile & """ palette is - " & index)
        oldBGpos = index      
      End If 
  '  End If
    RGB = HexRGB(R & "," & G & "," & B)
    PaletteArray(index) = RGB
    index = index + 1
  Next 
  ' Call CheckBMPColourPalette(inpath, infile)
End Sub



Sub CheckBMPColourPalette(inpath, infile)
  Dim i, ignore, palette, MyFile, R, G, B, RGB, index, temp 
  Dim parray(1024), showme, filename, bytecnt, remains
 
  Set MyFile = fso.OpenTextFile(inpath & "\" & infile, 1, False, 0)  
  
  ignore = MyFile.Read(54)
  palette = MyFile.Read(1024)  
  MyFile.Close
  Set MyFile = Nothing 

  index = 0
  For i = 1 to 1024
    parray(index) = Cbyte(Asc(Mid(palette,i,1)))    
    index = index + 1
  Next 

  filename = inpath & "\Test_" & bifname & ".txt"    
  If (fso.FileExists(filename)) Then
    fso.DeleteFile(filename)
  End If
  Set MyFile = fso.OpenTextFile(filename, ForAppending, True)
  bytecnt = 32
  remains = 1024
  index = 0
  Do Until (remains = 0)
    if (remains < bytecnt) then
      bytecnt = remains
    end if
    remains = remains - bytecnt    
    line = ": "
    for i = 1 to bytecnt
      temp = Left(HexRGB(parray(index) & ",0,0"), 2)  
      line = line & " " & temp  
      index = index + 1      
    next 
    MyFile.WriteLine line   
  Loop 
  MyFile.Close 
  Set MyFile = Nothing  
  
End Sub  

' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build palette Bif
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildPaletteBifBIN(inpath, infile)
  Dim i, index, filename, Hextable, BinBifCP, temp 

  filename = "Ref_" & Bifname & "_ColourPalette.bin" 

  Call WriteSLMsg(0,"... writing Colour Palette binary (for BIF) - """ & filename & """")

  If (fso.FileExists(inpath & "\" & filename)) Then
    fso.DeleteFile(inpath & "\" & filename)
  End If
 
  Set HexTable = wscript.createobject("adodb.stream") 
  HexTable.open
  HexTable.type = 1
  HexTable.loadfromfile(DefBPath & "BinaryTable.bin")

  Set BinBifCP = wscript.createobject("adodb.stream") 
  BinBifCP.open
  BinBifCP.type = 1  

  For index = 0 to 255
    temp = DecRGB(PaletteArray(index)) 
    temp = Split(RGB2Bif(temp), ",")
    HexTable.Position = temp(1)  
    HexTable.CopyTo BinBifCP, 1
    HexTable.Position = temp(0)  
    HexTable.CopyTo BinBifCP, 1 
  Next 
 
  BinBifCP.SetEOS
  BinBifCP.savetofile inpath & "\" & filename 

  WScript.DisconnectObject(HexTable) 
  WScript.DisconnectObject(BinBifCP)
    
End Sub          


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Other subs
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub SortBifDic()
  Dim i, j, temp, TempArray(), v1, v2, rc, Dickeys, Dicitems, dickey, dicitem
  
  Redim TempArray(BifDic.Count)
 
  Dickeys  = BifDic.Keys 
  Dicitems = BifDic.Items   
  For j = 0 To BifDic.Count -1   
    dickey  = Dickeys(j)
    dicitem = Dicitems(j)
    temp = Split(dicitem, ",")
    v1 = Right("000" & temp(2), 3)
    v2 = Right("000" & j, 3)
    TempArray(j) = v1 & "," & v2  
  Next
 
  rc = QuickSort(TempArray, UBound(TempArray), True)

  For j = 0 To UBound(TempArray)-1
    temp = Split(TempArray(j+1), ",")
    i = temp(1)
    If (SortedBifDic.Exists(Dickeys(i))) Then
      Call WriteErr(Error_DuplicateDicKey, "SortedBifDic/" & Dickeys(i))      
    Else  
      SortedBifDic.Add Dickeys(i), Dicitems(i)  
    End If  
  Next 
 
End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build the action pages dic 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildAPDic()
  Dim i, j, temp, Dickeys, Dicitems, dickey, dicitem, CA
  Dim key, item, xo, yo, x1, y1, x2, y2, temp2, CAprefix

  Dickeys  = SortedBifDic.Keys 
  Dicitems = SortedBifDic.Items   
  For i = 0 To SortedBifDic.Count -1 
  
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
    temp = Split(dickey, "\")
    temp2 = Split(temp(2), "_")
    CAprefix = temp2(0)

    If (CameraAngleDic.Exists(CAprefix)) Then
      CA = CameraAngleDic.Item(CAprefix) 
    Else
      CA = 0 
      Call WriteErr(Error_UnknownCameraAngle, dickey) 
    End If

    If (CA <> 0) Then
      temp = Split(dicitem,",")
      key = temp(0) & "_" & CA
      x1 = Cint(Int(temp(3)) / 2) 
      y1 = Cint(Int(temp(4)) / 2)
      x2 = Cint((Int(temp(3)) + Int(temp(1))) / 2)
      y2 = Cint((Int(temp(4)) + Int(temp(2))) / 2)
      xo = 10
      yo = 40
      item = xo & " " & yo & " " & x1 & " " & y1 & " " & x2 & " " & y2 
      If (APDic.Exists(key)) Then
        Call WriteErr(Error_DuplicateDicKey, "APDic/" & key)      
      Else     
        APDic.Add key, item  
      End If 
    End If

  Next
  
End Sub


