

' *************************************************************************************
' *************************************************************************************
' *** 
' *** Written by Wellington: Dec/2002 - Feb/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit

  Dim ImageFilePathDic, FilePathCnt, Horizontal, Vertical, Image1, Image2, CheckColour
  Dim Factionfolder, MaxH, MaxW, MaxHm1, MaxWm1

  CheckColour = HexRGB("0,128,0")   

  Set ImageFilePathDic = CreateObject("Scripting.Dictionary")
  Set Horizontal = CreateObject(Image_Package)  
  Set Vertical   = CreateObject(Image_Package)
  Set Image1   = CreateObject(Image_Package) 
  Set Image2   = CreateObject(Image_Package) 
  Set Image    = CreateObject(Image_Package)  
  Set Source   = CreateObject(Image_Package) 
   
  Call BuildAllFilePaths(OBMPPath)
  Call WritePathXref(ImageFilePathDic, "Ref_FileXref.txt", OBMPPath)   
  Call ProcessDic()

  Set ImageFilePathDic = Nothing
  Set Horizontal = Nothing
  Set Vertical   = Nothing 
  Set Image1   = Nothing
  Set Image2   = Nothing
  Set Image  = Nothing
  Set Source = Nothing 


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build an array (FilePathArray) of all files in a root folder (and subfolders) 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

' ***
' *** Start the recursion
' ***

Sub BuildAllFilePaths(rootfolder)
  Dim fso, onefolder
  Call WriteSLMsg(0,"... Building all file paths ...")  
  FilePathCnt = 0  
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set onefolder = fso.GetFolder(rootfolder)
  Call ShowFolderPaths(onefolder)  
End Sub

' ***
' *** Process folders
' ***

Sub ShowFolderPaths(onefolder)
  Dim folder, temp
  For Each folder In onefolder.SubFolders
    temp = Right(folder, Len(folder) - Len(OBMPPath)) 
    temp = Split(temp, "\")
    If (SelectionDic.Exists(temp(0))) Then
      Call ShowFilesPaths(folder)
      Call ShowFolderPaths(folder)
    End If
  Next
End Sub
 
' ***
' *** Process files
' ***

Sub ShowFilesPaths(folder)
  Dim file, i, filetype, pathfile, temp, Image
  For Each file in folder.Files 
    pathfile = Right(file, Len(File) - Len(OBMPPath))
    temp = Split(pathfile, "\") 
    If (Lcase(Right(pathfile, 4)) = ".bmp") Then
      Image = Left(pathfile, Len(pathfile)-8)
      If (Not ImageFilePathDic.Exists(Image)) Then   
        ImageFilePathDic.Add Image, Dummy      
        FilePathCnt = FilePathCnt + 1   
      End If 
    End If
  Next
End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build an array (FilePathArray) of all files in a root folder (and subfolders) 
' *** 
' ****************************************************************************** 
' ****************************************************************************** 

' ***
' *** Process the dictionary
' ***

Sub ProcessDic()
  Dim foldername, filename, mf, f1, f2, nf, mfsf, lastpath, createpath, topath
  Dim i, j, z, number, temp, Dickeys, Dicitems, dickey, dicitem, C1, C2, C3
  Dim lw, rw, lh, rh, neww, newh

  Call WriteSLMsg(0,"... Processing all folders ...")

  Call BuildAllFolders("Output\UnitImages", false)  

  C1 = HexRGB("0,132,0") 
  C2 = HexRGB("0,189,0")
  C3 = HexRGB("0,190,0")

  Dickeys  = ImageFilePathDic.Keys 
  Dicitems = ImageFilePathDic.Items   
  For i = 0 To ImageFilePathDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)
  
    temp = Split(dickey, "\") 
    Factionfolder = temp(0)

    Call BuildAllFolders("Output\UnitImages\" & temp(0), false)  
    Call BuildAllFolders("Output\UnitImages\" & temp(0) & "\" & temp(1), false)     

    Call WriteSLMsg(0,"... processing 12 images - " & dickey & " ...")

    For z = 1 to 12
      number = "_" & Right("000" & z, 3)
      Source.Readfile OBMPpath & dickey & number & ".bmp"

      If (z = 1) Then
        MaxH = Source.Height
        MaxW = Source.Width
        MaxHm1 = MaxH - 1
        MaxWm1 = MaxW - 1  
        Horizontal.NewImage MaxW*12, MaxH, "008000"
        Vertical.NewImage MaxW, MaxH*12, "008000"
      End If

      Source.FlipY
      Image1.NewImage MaxW, MaxH, "008000"
      Image1.Transparent = True
      Image1.BGcolor = C1  
      Image1.MergeBackBin Source.BMPData, "bmp", 0, 0     
      Image.NewImage MaxW, MaxH, "008000"
      Image.Transparent = True
      Image.BGcolor = C2  
      Image.MergeBackBin Image1.BMPData, "bmp", 0, 0      
      Horizontal.Transparent = True
      Horizontal.BGcolor = C3  
      Horizontal.MergeBackBin Image.BMPData, "bmp", MaxW*(z-1), 0   
      Vertical.Transparent = True
      Vertical.BGcolor = C3  
      Vertical.MergeBackBin Image.BMPData, "bmp", 0, MaxH*(z-1)   
    Next
    
    Call CheckHeightWidth(lw, rw, lh, rh)
   
    If (Int((rw-lw)/2)*2 <> rw-lw) Then
      rw = rw + 1
    End If
    If (Int((rh-lh)/2)*2 <> rh-lh) Then
      rh = rh + 1
    End If 

    neww = (rw-lw) 
    newh = (rh-lh)   

    ImageFilePathDic.Item(dickey) = neww & "," & newh

    Horizontal.ColorDepth = 8       
    Horizontal.Crop 0, lh , MaxW*12, rh  
    Horizontal.Writefile OImgPath & dickey & "_H.bmp"      
  
    j = 0
    For z = 1 to 12
      Image2.ReadStream "bmp", Horizontal.BMPData 
      Image2.Crop j+lw, 0, j+lw+neww, newh
      Image2.Writefile OImgPath & dickey & "_" & z & ".bmp"  
      j = j + MaxW      
    Next 
 
  Next

  Call WriteHWXref()   
  
End Sub


' *************************************************************************************
' *************************************************************************************
' ***
' *** Write Height/Width Xref 
' ***
' *************************************************************************************
' *************************************************************************************

 
Sub WriteHWXref()
  Dim i, line, filename, Dickeys, Dicitems, dickey, dicitem

  Call WriteSLMsg(0,"... writing ""HWXref.txt"" file ...")  

  filename = OImgPath & factionfolder & "\HWXref.txt"
  If (fso.FileExists(filename)) Then
    fso.DeleteFile(filename)
  End If
  
  Set MyFile = fso.OpenTextFile(filename, ForAppending, True)
 
  Dickeys  = ImageFilePathDic.Keys 
  Dicitems = ImageFilePathDic.Items   
  For i = 0 To ImageFilePathDic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)   
    line = dickey & " " & dicitem 
    MyFile.Writeline line
  Next

  MyFile.Close 
  Set MyFile = Nothing  
  
End Sub  


' *************************************************************************************
' ***
' *************************************************************************************


Sub CheckHeightWidth(lw, rw, lh, rh)
  Dim j
  For j = 0 to MaxWm1       
    If (Not CheckWidthSameColour(j)) Then 
      lw = j         
      Exit For
    End If 
  Next
  For j = MaxWm1 to 0 Step -1       
    If (Not CheckWidthSameColour(j)) Then  
      rw = j        
      Exit For
    End If 
  Next      
  For j = 0 to MaxHm1    
    If (Not CheckHeightSameColour(j)) Then
      lh = j
      Exit For        
    End If   
  Next
  For j = MaxHm1 to 0 Step -1    
    If (Not CheckHeightSameColour(j)) Then
      rh = j
      Exit For       
    End If   
  Next
End Sub 
  

' *************************************************************************************
' ***
' *************************************************************************************


Function CheckWidthSameColour(row)  
  Dim i, pc
  CheckWidthSameColour = False  
  For i = 0 to Vertical.Height-1
    pc = Vertical.Pixel(row, i)    
    If (pc <> CheckColour) Then 
      Exit Function
    End If 
  Next
  CheckWidthSameColour = True
End Function


' *************************************************************************************
' ***
' *************************************************************************************


Function CheckHeightSameColour(column)  
  Dim i, pc 
  CheckHeightSameColour = False  
  For i = 0 to Horizontal.Width-1
    pc = Horizontal.Pixel(i, column)    
    If (pc <> CheckColour) Then 
      Exit Function
    End If 
  Next
  CheckHeightSameColour = True
End Function


