
' *************************************************************************************
' *************************************************************************************
' ***
' *** LUKMAPMAKER - BETA VERSION (LMM4)  Copyright(c) 2003 
' ***
' *** THIS SUBPROGRAM
' ***
' *** This SubProgram reads all input txt files for LMM4
' *** 
' *** Written by Wellington: Dec/2002 - Jan/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit
 
   AdjustBIFDic.RemoveAll

   Call ReadAdjustBIF()


' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub ReadAdjustBIF() 
  Dim i, filepath, BIFname, foldername, action, actions, object, objects, subfolder, unitname, key
  Dim temp, parm, parms, keyword, parameter, allparms, bifpos, position, fandb
  Dim adjustRGB, adjustfrom, adjustto, adjustfc 

  Call WriteSLMsg(0,"Reading ""UMAdjustBIF.txt"" parameters ...") 
 
  CurrentFile = """UMAdjustBIF.txt""" 
  filepath = IPrmPath & "UMAdjustBIF.txt"   
 
  Call ReadTxtFile(filepath)  
  
  For i = 0 to Ubound(TxtFileArray)-1 
    TxtFileArray(i) = TxtFileArray(i) + OneSpace   
    temp = Split(TxtFileArray(i), "=")
    keyword = temp(0)

    Select Case Lcase(keyword)

       Case Lcase("folderandbif")
         fandb = ExtractKeywordParms(TxtFileArray(i), "FolderAndBif=", RP, "?")
         fandb = Split(fandb, ",")
         foldername = fandb(0)              
         bifname = fandb(1)         
         If (SelectionDic.Exists(foldername)) Then
           If (Not fso.FolderExists(OimgPath & foldername)) Then
             Call WriteErr(Error_InvalidFactionFolder, foldername)      
           End If      
           If (Not MTWBifDic.Exists(Ucase(bifname))) Then
             Call WriteErr(Error_InvalidBifName, bifname)      
           End If
           
           adjustFC    = ExtractKeywordParms(TxtFileArray(i), "AdjustFC=", RP, "999,999,999")
           adjustRGB   = ExtractKeywordParms(TxtFileArray(i), "AdjustRGB=", RP, "0,0,0")
           adjustfrom  = ExtractKeywordParms(TxtFileArray(i), "FromRGB=", RP, "0,0,0")
           adjustto    = ExtractKeywordParms(TxtFileArray(i), "ToRGB=", RP, "255,255,255")
           allparms = adjustRGB & "/" & adjustfrom & "/" & adjustto & "/" & adjustFC   
           AdjustBIFDic.Add foldername & "," & bifname, allparms 
         Else
           Call WriteSLMsg(0,"... ignoring """ & foldername & "," & bifname & """ parameters ...") 
         End If 
  
       Case Else 
         Call WriteErr(Error_InvalidKeyword, keyword) 
     
    End Select
   
  Next
  
End Sub


' ******************************************************************************** 
' ***
' *** Additional subs 
' ***
' ******************************************************************************** 

' ***
' *** extract the parameters pertaining to a keyword from a string
' ***

Function ExtractKeywordParms(instring, searchstring, endstring, notfound)
  Dim startpos, endpos, lenstring, copystring  
  ExtractKeywordParms = notfound
  copystring = Lcase(instring)
  startpos = InStr(copystring, Lcase(searchstring)) 
  If (startpos <> 0) Then
    startpos = startpos + Len(searchstring) + 1
    endpos = InStr(startpos, copystring, endstring)
    If (endpos <> 0) Then
      lenstring = endpos - startpos   
      ExtractKeywordParms = Mid(instring, startpos, lenstring)
    End If 
  End If  
End Function

' *** validate 2 numbers

Function Valid2Numbers(num1, num2, inparm)
  Dim temp
  Valid2Numbers = False 
  temp = Replace(inparm, "(", "")
  temp = Replace(temp, ")", "")  
  temp = Split(temp, ",")
  If (Ubound(temp) <> 1) Then Exit Function
  If (Not IsNumeric(temp(0))) Then Exit Function  
  If (Not IsNumeric(temp(1))) Then Exit Function   
  num1 = temp(0)
  num2 = temp(1)
  Valid2Numbers = True
End Function

' *** validate a user specified RGB

Function ValidColours(toparm, RGB)
  Dim temp
  ValidColours = False 
  temp = Replace(RGB, "(", "")
  temp = Replace(temp, ")", "")  
  temp = Split(temp, ",")
  If (Ubound(temp) <> 2) Then Exit Function
  If (Not IsNumeric(temp(0))) Then Exit Function  
  If (Not IsNumeric(temp(1))) Then Exit Function  
  If (Not IsNumeric(temp(2))) Then Exit Function  
  If (temp(0) < 0) or (temp(0) > 255) Then Exit Function  
  If (temp(1) < 0) or (temp(1) > 255) Then Exit Function  
  If (temp(2) < 0) or (temp(2) > 255) Then Exit Function  
  toparm = HexRGB(RGB)
  ValidColours = True
End Function


' *** if value = yes, true is returned 
' *** if value = no, false is returned 

Function IfYes(keyword, value)  
  IfYes = True 
  If (Lcase(value) = "yes") Then Exit Function  
  If (Lcase(value) <> "no") Then
    Call WriteErr(Error_InvalidParameter, keyword)
    Exit Function
  End If         
  IfYes = False
End Function

' *** 

Sub ValidateActions(inparms)  
  Dim i, temp, temp2, act, id  
  temp = Split(inparms, ",")
  For i = 0 to Ubound(temp)
    temp2 = Split(temp(0), "/")
    act = Lcase(temp2(0))
    If (Not ActionsObjectsDic.Exists(act)) Then
      Call WriteErr(Error_ActionsParameterActionNotFound, temp2(0))
    ElseIf (ActionsObjectsDic.Item(act) <> "ACTION") Then
      Call WriteErr(Error_ActionsParameterActionNotFound, temp2(0))
    End If   
    If (Ubound(temp2) = 1) then
      If (Not TempPosDic.Exists(Lcase(temp2(1)))) then
        Call WriteErr(Error_ActionsParameterIdentifierNotFound, temp2(1))
      End If
    End If 
  Next
End Sub

' *** 

Sub ValidateObject(inparms)  
  Dim temp  
  temp = Split(inparms, ",")
  If (TempObjDic.Exists(temp(0))) Then
    Call WriteErr(Error_ObjectAlreadySpecified, temp(0))
    Exit Sub
  Else
    TempObjDic.Add temp(0), Dummy
  End If  
  If (Left(temp(0), 1) = "S") Then
    If (Ubound(temp) <> 1) Then
      Call WriteErr(Error_InvalidObjectSParameter, inparms)
      Exit Sub
    End If
  ElseIf (Left(temp(0), 1) = "W") Then
    If (Ubound(temp) <> 3) Then
      Call WriteErr(Error_InvalidObjectWParameter, inparms)
      Exit Sub
    End If
  Else
    Call WriteErr(Error_InvalidObjectSWParameter, temp(0))
    Exit Sub
  End If
  If (Not fso.FileExists(IobjPath & temp(1) & ".bmp")) then
    Call WriteErr(Error_InvalidObjectSWNotFound, temp(1) & ".bmp")
    Exit Sub
  End If 
 
End Sub


' *** 

Sub ValidatePositions(inparms)
  Dim temp  
  temp = Split(inparms, ",") 
  If (TempPosDic.Exists(Lcase(temp(0)))) Then
    Call WriteErr(Error_PositionIDAlreadySpecified, temp(0))
    Exit Sub
  Else
    TempPosDic.Add Lcase(temp(0)), Dummy
  End If   
 
End Sub




