
' *************************************************************************************
' *************************************************************************************
' ***
' *** LUKMAPMAKER - BETA VERSION (LMM4)  Copyright(c) 2003 
' ***
' *** THIS SUBPROGRAM
' ***
' *** This SubProgram reads all input txt files for LMM4
' *** 
' *** Written by Wellington: Dec/2002 - Jan/2003 
' ***
' *************************************************************************************
' *************************************************************************************

 Option Explicit

    ResizeDic.RemoveAll
    ResizeActionDic.RemoveAll

    Call ReadUMParameters() 
    Call BuildMTWBifsDic() 
    Call BuildActionsObjectsDic() 
    Call BuildMTWItemsDic()
    Call BuildMTWItemNamesDic() 


' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub ReadUMParameters() 
  Dim i, faction, filepath, temp, keyword, parameter, foldername, percent, FS, HW, actionname 
  CurrentFile = """UMParameters.txt""" 

  filepath = IPrmPath & "UMParameters.txt" 
  Call WriteSLMsg(0,"Init: reading ""UMParameters.txt"" parameters ...") 
  Call ReadTxtFile(filepath)
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), "=")
    keyword = temp(0)
    parameter = temp(1)
    Select Case Lcase(keyword)
      Case "testmode"
        If (Lcase(parameter) = "yes") Then
          testmode = True
        Else
          testmode = False
        End If  
      Case "warnings"
        If (Lcase(parameter) = "yes") Then
          warnings = True
        Else
          warnings = False
        End If  
      Case "showadjustedrgbs"
        If (Lcase(parameter) = "yes") Then
          showadjustedrgbs = True
        Else
          showadjustedrgbs = False
        End If 
      Case "resizefactionpcxs"
        If (Not ValidResize(foldername, percent, parameter)) Then 
          Call WriteErr(Error_InvalidParameter, keyword) 
        Else    
          If (Not fso.FolderExists(IpcxPath & foldername)) Then
            Call WriteErr(Error_InvalidFactionFolder, foldername) 
          Else 
            If (ResizeDic.Exists(foldername)) Then
              Call WriteErr(Error_DuplicateDicKey, "ResizeDic/" & foldername)      
            Else
              ResizeDic.Add foldername, percent
            End If     
          End If   
        End If 
      Case "resizeactionbmps"
        FS = ExtractKeywordParms(TxtFileArray(i), "ResizeActionBmps=", RP, "?")
        HW = ExtractKeywordParms(TxtFileArray(i), "WidthHeight=", RP, "?")
        If (Not ValidResize2(foldername, actionname, percent, FS, HW)) Then 
          Call WriteErr(Error_InvalidParameter, keyword) 
        Else        
          If (Not fso.FolderExists(IpcxPath & foldername)) Then
            Call WriteErr(Error_InvalidFactionFolder, foldername) 
          Else 
            If (ResizeActionDic.Exists(foldername)) Then
              Call WriteErr(Error_DuplicateDicKey, "ResizeActionDic/" & foldername)      
            Else
              ResizeActionDic.Add foldername & "," & actionname, percent
            End If
          End If   
        End If 
      Case "cameraangle1"
        Call CheckCameraAngle(1,parameter) 
      Case "cameraangle2"
        Call CheckCameraAngle(2,parameter) 
      Case "cameraangle3"
        Call CheckCameraAngle(3,parameter) 
      Case "cameraangle4"
        Call CheckCameraAngle(4,parameter) 

      Case Else 
        Call WriteErr(Error_InvalidKeyword, keyword)      
    End Select  
    
  Next

End Sub



' validate the parameters

Sub CheckCameraAngle(angle, inparms)
  Dim i, temp
  temp = Replace(inparms, "(", "")
  temp = Replace(temp, ")", "") 
  temp = Split(temp, ",") 
  For i = 0 to Ubound(temp)    
    If (CameraAngleDic.Exists(temp(i))) Then 
      Call WriteErr (Error_DuplicateCA, temp(i))  
    Else 
      CameraAngleDic.Add temp(i), angle 
    End If
  Next
End Sub


' validate the parameters

Function ValidResize(tofolder, topercent, inparms)
  Dim temp
  ValidResize = False 
  temp = Replace(inparms, "(", "")
  temp = Replace(temp, ")", "") 
  temp = Replace(temp, "%", "")   
  temp = Split(temp, ",")
  If (Ubound(temp) <> 1) Then Exit Function
  If (Not IsNumeric(temp(1))) Then Exit Function 
  tofolder = Lcase(temp(0))
  topercent = temp(1)
  ValidResize = True
End Function


Function ValidResize2(tofolder, toaction, topercent, inparms1, inparms2)
  Dim temp1, temp2
  ValidResize2 = False 
  temp1 = Split(inparms1, ",") 
  temp2 = Replace(inparms2, "%", "")
  temp2 = Replace(temp2, "%", "")
  temp2 = Split(temp2, ",") 
  If (Ubound(temp1) <> 1) Then Exit Function
  If (Ubound(temp2) <> 1) Then Exit Function
  If (Not IsNumeric(temp2(0))) Then Exit Function 
  If (Not IsNumeric(temp2(1))) Then Exit Function 
  tofolder = Lcase(temp1(0)) 
  toaction = Lcase(temp1(1))
  topercent = temp2(0) & "," & temp2(1)
  ValidResize2 = True
End Function

' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub BuildMTWBifsDic() 
  Dim i, faction, filepath, temp, parms, parmlist, keywords 
  CurrentFile = """MTWGenericBifs.txt""" 

  filepath = DefFPath & "MTWGenericBifs.txt" 
  Call WriteSLMsg(0,"Init: reading ""MTWGenericBifs.txt"" parameters ...") 
  Call ReadTxtFile(filepath)
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), " ") 
    If (Ubound(temp) <> 1) Then 
      Call WriteErr (Error_InvalidNoOfParameters, TxtFileArray(i))  
    Else 
      MTWBifDic.Add temp(1), temp(0) 
    End If
  Next

End Sub


' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub BuildMTWItemsDic() 
  Dim i, faction, filepath, temp, parms, parmlist, keywords 
  CurrentFile = """MTWItemFolders.txt""" 

  filepath = DefFPath & "MTWItemFolders.txt" 
  Call WriteSLMsg(0,"Init: reading ""MTWItemFolders.txt"" parameters ...") 
  Call ReadTxtFile(filepath)
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), " ") 
    If (Ubound(temp) <> 1) Then 
      Call WriteErr (Error_InvalidNoOfParameters, TxtFileArray(i))  
    Else 
      MTWItemsDic.Add temp(0), temp(1) 
    End If
  Next

End Sub


' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub BuildMTWItemNamesDic() 
  Dim i, faction, filepath, temp, parms, parmlist, keywords 
  CurrentFile = """MTWItemActions.txt""" 

  filepath = DefFPath & "MTWItemActions.txt" 
  Call WriteSLMsg(0,"Init: reading ""MTWItemActions.txt"" parameters ...") 
  Call ReadTxtFile(filepath)
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), " ") 
    If (Ubound(temp) <> 1) Then 
      Call WriteErr (Error_InvalidNoOfParameters, TxtFileArray(i))  
    Else 
      MTWItemNamesDic.Add Lcase(temp(0)), Lcase(temp(1)) 
    End If
  Next

End Sub



' ******************************************************************************** 
' ***
' *** 
' ******************************************************************************** 


Sub BuildActionsObjectsDic() 
  Dim i, faction, filepath, temp, parms, parmlist, keywords 
  CurrentFile = """MTWActionsObjects.txt""" 

  filepath = DefFPath & "MTWActionsObjects.txt" 
  Call WriteSLMsg(0,"Init: reading ""MTWActionsObjects.txt"" parameters ...") 
  Call ReadTxtFile(filepath)
  
  For i = 0 to Ubound(TxtFileArray)-1
    temp = split(TxtFileArray(i), " ") 
    If (Ubound(temp) <> 1) Then 
      Call WriteErr (Error_InvalidNoOfParameters, TxtFileArray(i))  
    Else 
      ActionsObjectsDic.Add Lcase(temp(1)), temp(0) 
    End If
  Next

End Sub


' ******************************************************************************** 
' ***
' *** Additional subs 
' ***
' ******************************************************************************** 

' ***
' *** extract the parameters pertaining to a keyword from a string
' ***

Function ExtractKeywordParms(instring, searchstring, endstring, notfound)
  Dim startpos, endpos, lenstring, copystring  
  ExtractKeywordParms = notfound
  copystring = Lcase(instring)
  startpos = InStr(copystring, Lcase(searchstring)) 
  If (startpos <> 0) Then
    startpos = startpos + Len(searchstring) + 1
    endpos = InStr(startpos, copystring, endstring)
    If (endpos <> 0) Then
      lenstring = endpos - startpos   
      ExtractKeywordParms = Mid(instring, startpos, lenstring)
    End If 
  End If  
End Function

' *** validate 2 numbers

Function Valid2Numbers(num1, num2, inparm)
  Dim temp
  Valid2Numbers = False 
  temp = Replace(inparm, "(", "")
  temp = Replace(temp, ")", "")  
  temp = Split(temp, ",")
  If (Ubound(temp) <> 1) Then Exit Function
  If (Not IsNumeric(temp(0))) Then Exit Function  
  If (Not IsNumeric(temp(1))) Then Exit Function   
  num1 = temp(0)
  num2 = temp(1)
  Valid2Numbers = True
End Function

' *** validate a user specified RGB

Function ValidColours(toparm, RGB)
  Dim temp
  ValidColours = False 
  temp = Replace(RGB, "(", "")
  temp = Replace(temp, ")", "")  
  temp = Split(temp, ",")
  If (Ubound(temp) <> 2) Then Exit Function
  If (Not IsNumeric(temp(0))) Then Exit Function  
  If (Not IsNumeric(temp(1))) Then Exit Function  
  If (Not IsNumeric(temp(2))) Then Exit Function  
  If (temp(0) < 0) or (temp(0) > 255) Then Exit Function  
  If (temp(1) < 0) or (temp(1) > 255) Then Exit Function  
  If (temp(2) < 0) or (temp(2) > 255) Then Exit Function  
  toparm = HexRGB(RGB)
  ValidColours = True
End Function

' if value = yes, true is returned 
' if value = no, false is returned 

Function IfYes(keyword, value)  
  IfYes = True 
  If (Lcase(value) = "yes") Then Exit Function  
  If (Lcase(value) <> "no") Then
    Call WriteErr(Error_InvalidParameter, keyword)
    Exit Function
  End If         
  IfYes = False
End Function

' ***
' *** extract the parameters pertaining to a keyword from a string
' ***

Function ExtractKeywordParms(instring, searchstring, endstring, notfound)
  Dim startpos, endpos, lenstring, copystring  
  ExtractKeywordParms = notfound
  copystring = Lcase(instring)
  startpos = InStr(copystring, Lcase(searchstring)) 
  If (startpos <> 0) Then
    startpos = startpos + Len(searchstring) + 1
    endpos = InStr(startpos, copystring, endstring)
    If (endpos <> 0) Then
      lenstring = endpos - startpos   
      ExtractKeywordParms = Mid(instring, startpos, lenstring)
    End If 
  End If  
End Function