
' *************************************************************************************
' *************************************************************************************
' ***
' *** Unit Modder BETA VERSION (UM1v1)  Copyright(c) 2003 
' ***
' ***
' *** Written by Wellington: Mar/2003 
' ***
' *************************************************************************************
' *************************************************************************************

Option Explicit

' *************************************************************************************
' ***
' *** Define storage and constants
' ***
' *************************************************************************************


Const UMshortversion = "UM_LoTR r1v3"
' Const UMlongversion  = "Release 1 Version 3"
Const UMlongversion  = "PRE-RELEASE VERSION!!!"


Dim x, y, H, W, RGB
Dim OurDate, OurTime, MsgID
Dim Allitems, Allkeys, Oneitem, Onekey
Dim CurrentFile, AllTablesBuilt 
Dim Msgfso, Errfso, SLogfilename, Msgfilename, Errfilename  
Dim MsgCount, ErrCount, WrnCount  
Dim Image, Source
Dim fileFSO, folderID, folderlist, prompt, title, line
Dim TxtFileArray, TxtFileLineNum, TxtFileIndex, fso, MyFile, Version
Dim bordersize, maxW, maxH, newW, newH, centreW, centreH
Dim ColourIndex, ColourMap(1,1)
Dim BackGroundX, BackGroundY, BackGroundRGB
Dim ShadowX, ShadowY, ShadowRGB, RCtype, BmpRows, BmpColumns, BmpSquared
Dim PaletteArray(256)

Dim ShowAdjustedRGBs : ShowAdjustedRGBs = False
Dim OnErrorQuit : OnErrorQuit = False
Dim testmode : testmode = False
Dim warnings : warnings = True

Dim RootPath, BRPath, SubPath
Dim IPcxPath, IObjPath, IPosPath, IPrmPath
Dim IPicPath, IPicIPPath, IPicRPPath, IPicUIPath 
Dim OBmpPath, OImgPath, OFrmPath, OMTWPath, OObjpath
Dim DefIPath, DefBPath, DefTPath, DefPPath, DefFPath 

' ***
' *** Define UM parameters
' ***

Dim MiniBifMM, MiniBifML, MiniBifFM, MiniBifFL
Dim MTWProd11, MTWBuild13, MTWProjStats

' ***
' *** Define basic dictionaries. 
' *** 

Dim SelectionDic, TempDic
Dim SelectionDicCnt, TempDicCnt
Dim MTWBifDic, MTWItemsDic, MTWItemNamesDic, DefineUnitsDic, ActionsObjectsDic, FactionBifDic
Dim ResizeDic, AdjustBIFDic, ResizeActionDic
Dim BifDic, SortedBifDic, UnitDic, UnitBifDic, APDic
Dim ObjectXrefDic, ObjectDic, ObjectIRDic,PositionDic,CameraAngleDic

' ***
' *** one or two odd constants
' ***

Const Delete   = ""
Const OneSpace = " "
Const TwoSpace = "  "
Const Quote    = """"
Const Comma    = ","
Const LP       = "("
Const RP       = ")"
Const Dummy    = "Dummy" 
Const ForReading = 1, ForWriting = 2, ForAppending = 8
Const Colour_White        = "FFFFFF"   ' (ie: RGB ="255,255,255") 
Const Colour_Black        = "000000"   ' (ie: RGB ="0,0,0")
Const Colour_MinimapSea   = "000C30"   ' (ie: RGB ="0,12,48")
Const Colour_MinilukupSea = "008000"   ' (ie: RGB ="0,128,0")
Const Hires = "_H.bif"
Const Lores = ".bif"

Dim Image_Package : Image_Package = "csImageFileTrial.Manage" 

' ***
' *** Main GUI options
' ***

Const ID_BuildOne5Stages = 1  
Const ID_BuildOneBMP = 2
Const ID_BuildOneImage = 3  
Const ID_BuildOneFrame = 4  
Const ID_BuildOneBIF = 5

Const ID_BuildAll5Stages = 6  
Const ID_BuildAllBMP = 7
Const ID_BuildAllImage = 8  
Const ID_BuildAllFrame = 9  
Const ID_BuildAllBIF = 10

Const ID_GenProd11 = 11
Const ID_GenDeadPage = 12

Const ID_Cancel = 13

Dim UM, UMHasRun, StopProcessing 
Dim SelectionName
Dim PcxFolder, BmpFolder, FrameFolder, BifFolder

Dim oNMD, oForm 
Dim m_btnBuildOneSpareID, m_btnBuildOneBMPID, m_btnBuildOneImageID, m_btnBuildOneFrameID, m_btnBuildOneBIFID
Dim m_btnBuildAllSpareID, m_btnBuildAllBMPID, m_btnBuildAllImageID, m_btnBuildAllFrameID, m_btnBuildAllBIFID
Dim m_btnGenProd11ID, m_btnGenDeadPageID
Dim m_btnCancelID 
 
Dim oNMDbCloseFlag, oNMDbCancelClick, oNMDbStartClick, sDlgCaption

' ***
' *** Install/Backout variables
' ***

Dim UMpathIB, MTW1pathIB, MTW2pathIB, SubpathIB, IBfilename, IBkeyword
Dim IBType
Const IBType_Install = "Install"
Const IBType_Backout = "Backout"

' ***
' *** Error/Warning constants
' ***

Const Error_InvalidFactionFolder = 1
Const Error_InvalidBifName = 2
Const Error_FactionNotFound = 3
Const Error_InvalidAction = 4
Const Error_FolderNotFound = 5 
Const Error_DuplicateDicKey = 6
Const Error_InvalidKeyword = 7
Const Error_InvalidParameter = 8 
Const Error_UnknownCameraAngle = 9
Const Error_BifNameSpecifiedTwice = 10
Const Error_UnitNameSpecifiedTwice = 11
Const Error_InvalidObjectSParameter = 12
Const Error_InvalidObjectWParameter = 13
Const Error_InvalidObjectSWParameter = 14
Const Error_InvalidObjectSWNotFound = 15
Const Error_ObjectAlreadySpecified = 16
Const Error_ActionsParameterActionNotFound = 17
Const Error_ActionsParameterIdentifierNotFound = 18
Const Error_PositionIDAlreadySpecified = 19
Const Error_DuplicateCA = 20



Const Warning_ShieldPosFileNotFound = 50
Const Warning_WeaponPosFileNotFound = 51


' ***********************************************************************************************
' ***
' *** Main Dialog
' *** 
' *** This the main routine that basically calls other routines for the path definitions,
' *** the GUI, the main caller routine and all Object init/term routines
' ***
' *** Once all the prilimanary work has been done this routine calls either the "MainCaller" (for
' *** 'BuildOneBIF' type runs) or "ScriptRun" (for 'Script' type runs). 
' *** These two routines contains all the major calls to other subroutines/functions that REALLY 
' *** do all the work!
' ***
' ***********************************************************************************************

  Call Instantiate(oNMD, "wshLtWtNonModalDialog.ucNMD", "oNMD_")  ' as Object
  OurDate = Date
  OurTime = Time

  Call ObjectInit()
  Call GetOurPath()

  Call WriteSLMsg(2," ")  
  Call WriteSLMsg(2,"*** UM Session started -  " & OurDate & " " & OurTime & " ***")  
  Call WriteSLMsg(2," ")   

  sDlgCaption = "UM_LoTR - " & UMlongversion & " (" & UMshortversion & ")" 
  oNMDbCloseFlag = False
  
  Call Create_Form(sDlgCaption)

  Call EGSubroutine("UM_ReadInputFiles.vbs")

  UMHasRun = False  
  Do 
    StopProcessing = False     
    WScript.Sleep 100  ' allow for doevents (if necessary) ... sigh!!! 

    Call ShowMainButtons()
    Call InitAllVariables() 
    
    If oNMDbStartClick Then
      oNMDbStartClick = false 
       
      SelectionDic.RemoveAll  
  
      Select Case UM

        Case ID_BuildOneBMP
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_BuildBMP.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 

        Case ID_BuildOneImage
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_BuildImage.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 

        Case ID_BuildOneFRAME
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_ReadDefineUnits.vbs")
            Call EGSubroutine("UM_BuildFRAME.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 
        
        Case ID_BuildOneBIF
          Call GetSelectionName()
          If (SelectionName <> "") Then
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..."
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...") 
            Call EGSubroutine("UM_ReadDefineUnits.vbs")
            Call EGSubroutine("UM_ReadAdjustBIF.vbs")   
            Call EGSubroutine("UM_BuildBIF.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If

        Case ID_BuildOne5Stages
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            UM = ID_BuildOneBMP
            Call EGSubroutine("UM_BuildBMP.vbs")
            UM = ID_BuildOneImage
            Call EGSubroutine("UM_BuildImage.vbs")
            UM = ID_BuildOneFrame
            Call EGSubroutine("UM_ReadDefineUnits.vbs")           
            Call EGSubroutine("UM_BuildFRAME.vbs")
            UM = ID_BuildOneBIF
            Call EGSubroutine("UM_ReadAdjustBIF.vbs")   
            Call EGSubroutine("UM_BuildBIF.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 

      
        Case ID_BuildAllBMP
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_BuildBMP.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 

        Case ID_BuildAllImage
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_BuildImage.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If        

        Case ID_BuildAllFRAME
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_ReadDefineUnits.vbs")
            Call EGSubroutine("UM_BuildFRAME.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If 
        
        Case ID_BuildAllBIF
          Call GetSelectionName()
          If (SelectionName <> "") Then
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..."
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            Call EGSubroutine("UM_ReadDefineUnits.vbs")
            Call EGSubroutine("UM_ReadAdjustBIF.vbs")    
            Call EGSubroutine("UM_BuildBIF.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If

        Case ID_BuildAll5Stages 
          Call GetSelectionName()
          If (SelectionName <> "") Then
            Call HideMainButtons()
            oNMD.frmDialog.Label(3) = "Processing " & SelectionName & " ..." 
            Call WriteSLMsg(0,"Processing """ & SelectionName & """ ...")
            UM = ID_BuildAllBMP
            Call EGSubroutine("UM_BuildBMP.vbs")
            UM = ID_BuildAllImage
            Call EGSubroutine("UM_BuildImage.vbs")          
            UM = ID_BuildAllFrame
            Call EGSubroutine("UM_ReadDefineUnits.vbs")
            Call EGSubroutine("UM_BuildFRAME.vbs")
            UM = ID_BuildAllBIF
            Call EGSubroutine("UM_ReadAdjustBIF.vbs")   
            Call EGSubroutine("UM_BuildBIF.vbs")
            Call WriteSLMsg(0,"Finished. (" & ErrCount & " Errors, " & WrnCount & " Warnings)")
            Call ShowMainButtons()
          End If        
          
        Case ID_GenProd11
          MsgBox "This option is not yet available"  

        Case ID_GenDeadPage
          MsgBox "This option is not yet available"         
                        
        Case ID_Cancel    
      
        Case Else
          MsgBox "UM1v1 Internal Error - oNMD Else!"

      End Select      
       
      If (UMHasRun) Then
        Call WriteSLMsg(0,"Finished. " & ErrCount & " error(s), " & WrnCount & " warning(s) found.")
        Call ResetAllDics() 
        UMHasRun = False  
      End If      
    End If   
  Loop Until (oNMDbCloseFlag or oNMDbCancelClick)

  oNMD.ShowDialog False ' clean up
  oNMD.UnloadDialog  
  set oNMD = Nothing
  set oForm = Nothing

  Call ObjectTerm()
  Wscript.quit

' ***
' *** Hide the main buttons once we start a run
' ***

Sub HideMainButtons()
  oNMD.frmDialog.Button(1).Visible = False 
  oNMD.frmDialog.Button(2).Visible = False
  oNMD.frmDialog.Button(3).Visible = False
  oNMD.frmDialog.Button(4).Visible = False 
  oNMD.frmDialog.Button(5).Visible = False
  oNMD.frmDialog.Button(6).Visible = False
  oNMD.frmDialog.Button(7).Visible = False 
  oNMD.frmDialog.Button(8).Visible = False 
  oNMD.frmDialog.Button(9).Visible = False 
  oNMD.frmDialog.Button(10).Visible = False 
  oNMD.frmDialog.Button(11).Visible = False 
  oNMD.frmDialog.Button(12).Visible = False 
End Sub

' ***
' *** Show the main buttons after we finish a run
' *** (not the 3 main processing routines)
' *** 

Sub ShowMainButtons()  
  oNMD.frmDialog.Button(1).Visible = True 
  oNMD.frmDialog.Button(2).Visible = True 
  oNMD.frmDialog.Button(3).Visible = True  
  oNMD.frmDialog.Button(4).Visible = True 
  oNMD.frmDialog.Button(5).Visible = True 
  oNMD.frmDialog.Button(6).Visible = True 
  oNMD.frmDialog.Button(7).Visible = True 
  oNMD.frmDialog.Button(8).Visible = True 
  oNMD.frmDialog.Button(9).Visible = True 
  oNMD.frmDialog.Button(10).Visible = True
  oNMD.frmDialog.Button(11).Visible = True
  oNMD.frmDialog.Button(12).Visible = True
End Sub


' ***********************************************************************************************
' ***
' *** Reset all Dictionaries
' *** 
' ***********************************************************************************************


Sub ResetAllDics()

  MTWBifDic.RemoveAll  
  MTWItemsDic.RemoveAll  
  TempDic.RemoveAll 
  ActionsObjectsDic.RemoveAll
  FactionBifDic.RemoveAll

  AllTablesBuilt = False  

End Sub

' ***********************************************************************************************
' ***
' *** Initialise all variables
' *** 
' ***********************************************************************************************


Sub InitAllVariables()

  AllTablesBuilt = False 

  MsgCount  = 0 
  ErrCount  = 0
  WrnCount = 0  

End Sub


' ***********************************************************************************************
' ***
' *** Standard Object init/term routines
' *** 
' ***********************************************************************************************

' Create all objects we intend using in this utility - ok, many would argue this is not 100% 
' efficient in that we should really initialise an object ONLY when we are about to use it, and then 
' release it IMMEDIATELY after use. I know all this - BUT - it's far easier to show people who
' may wish to use/copy/amend/crib this code exactly which objects we are using. Putting them all in
' one place may assist in this.
' Basically its a case of - C'mon let's try to be a bit user friendly here and not worry about another 
' few K of storage that Windows will have to allocate for these objects (the 286 days are long gone!) 

Sub ObjectInit()
 
  Set MTWBifDic    = CreateObject("Scripting.Dictionary")  
  Set MTWItemsDic  = CreateObject("Scripting.Dictionary") 
  Set MTWItemNamesDic  = CreateObject("Scripting.Dictionary")   
  Set TempDic      = CreateObject("Scripting.Dictionary")
  Set DefineUnitsDic = CreateObject("Scripting.Dictionary")
  Set ActionsObjectsDic = CreateObject("Scripting.Dictionary")
  Set SelectionDic = CreateObject("Scripting.Dictionary") 
  Set FactionBifDic  = CreateObject("Scripting.Dictionary") 
  Set AdjustBIFDic = CreateObject("Scripting.Dictionary") 

  Set BifDic = CreateObject("Scripting.Dictionary")
  Set UnitBifDic = CreateObject("Scripting.Dictionary")
  Set UnitDic = CreateObject("Scripting.Dictionary")
  Set ObjectDic = CreateObject("Scripting.Dictionary")
  Set ObjectIRDic = CreateObject("Scripting.Dictionary")
  Set ObjectXrefDic = CreateObject("Scripting.Dictionary")
  Set SortedBifDic = CreateObject("Scripting.Dictionary")
  Set PositionDic = CreateObject("Scripting.Dictionary")
  Set APDic = CreateObject("Scripting.Dictionary")
  Set ResizeDic = CreateObject("Scripting.Dictionary")
  Set ResizeActionDic = CreateObject("Scripting.Dictionary")
  Set CameraAngleDic = CreateObject("Scripting.Dictionary")

    
  Set Msgfso = CreateObject("Scripting.FileSystemObject")
  Set Errfso = CreateObject("Scripting.FileSystemObject")
  Set fso    = CreateObject("Scripting.FileSystemObject") 

End Sub

' release all the objects (ie: the storage/memory that Windows allocates to 
' such control blocks), that we have been using (or MAY have used)
 
Sub ObjectTerm()
 
  Set MTWBifDic    = Nothing 
  Set MTWItemsDic  = Nothing 
  Set MTWItemNamesDic  = Nothing 
  Set TempDic      = Nothing
  Set DefineUnitsDic = Nothing 
  Set ActionsObjectsDic = Nothing
  Set SelectionDic = Nothing
  Set FactionBifDic = Nothing
  Set AdjustBIFDic = Nothing


  Set BifDic = Nothing
  Set UnitBifDic = Nothing
  Set UnitDic = Nothing
  Set ObjectDic = Nothing
  Set ObjectIRDic = Nothing
  Set ObjectXrefDic = Nothing
  Set SortedBifDic = Nothing 
  Set PositionDic = Nothing 
  Set APDic = Nothing
  Set ResizeDic = Nothing 
  Set ResizeActionDic = Nothing 
  Set CameraAngleDic = Nothing

  Set Msgfso = Nothing
  Set Errfso = Nothing
  Set fso    = Nothing 

End Sub


' ***********************************************************************************************
' ***
' *** Dialog Subroutines
' ***
' ***********************************************************************************************

' *** Click event handlers 

Sub oNMD_ButtonClick(btnID)   

  UM = 0

  oNMDbStartClick = True
  Select Case btnID

    Case m_btnBuildOneSpareID 
      UM = ID_BuildOne5Stages
    Case m_btnBuildOneBMPID 
      UM = ID_BuildOneBMP
    Case m_btnBuildOneImageID 
      UM = ID_BuildOneImage
    Case m_btnBuildOneFrameID 
      UM = ID_BuildOneFrame
    Case m_btnBuildOneBIFID 
      UM = ID_BuildOneBIF
    
    Case m_btnBuildAllSpareID 
      UM = ID_BuildAll5Stages
    Case m_btnBuildAllBMPID 
      UM = ID_BuildAllBMP
    Case m_btnBuildAllImageID 
      UM = ID_BuildAllImage
    Case m_btnBuildAllFrameID 
      UM = ID_BuildAllFrame
    Case m_btnBuildAllBIFID 
      UM = ID_BuildAllBIF

    Case m_btnGenProd11ID 
      UM = ID_GenProd11
    Case m_btnGenDeadPageID 
      UM = ID_GenDeadPage

    Case m_btnCancelID
      UM = ID_Cancel
      oNMDbCancelClick = True 

    Case Else
      oNMDbStartClick = False

  End Select
  
End Sub


Sub oNMD_UserClose()   
  oNMDbCloseFlag = True
End Sub


' *** Create the form / add the controls 

Sub Create_Form(sCaption)
  Dim wdForm, htForm, htWindow, wdBtn, htBtn, wdBtnSp, xPos, yPos, Btnspace, TempImage  
  Dim  ScreenWd, ScreenHt, btnline1, btnline2, btnline3, btnline4
 
  Set oForm = oNMD.frmDialog 
  Set TempImage = CreateObject(Image_Package)
  Version    = TempImage.Version
  Set TempImage = Nothing  
  Const sLBLabel = "Click on one the buttons below ..."
  Const margin = 20  
  wdBtn = 135 
  htBtn = 25
  wdForm = 775 
  htWindow = 350
  htForm = htWindow + (4*(htBtn+8)) 
  With CreateObject("htmlfile").ParentWindow.Screen
    ScreenWd = .AvailWidth
    ScreenHt = .AvailHeight
  End With
  xPos = (ScreenWd - wdForm) / 2
  yPos = (ScreenHt - htForm) / 2
  oNMD.CreateDialog sCaption, Int(xPos), Int(yPos), wdForm, htForm
  oNMD.MinMaxBtns = False
  oNMD.AddLabel "Graphics DLL:", 20,10, 90,25
  oNMD.AddLabel Version, 120,10, 440,25
  oNMD.AddLabel sLBLabel, 20,40, 300,20
  oNMD.AddLstBox margin, 60, wdForm-(margin*2), 250 ' htWindow 
  Btnspace = wdBtn+16

  btnline1 = htForm-((htBtn+8)*5)
  btnline2 = htForm-((htBtn+8)*4)
  btnline3 = htForm-((htBtn+8)*3)
  btnline4 = htForm-((htBtn+8)*2)

  oNMD.AddButton "Build Faction BMPs", margin, btnline1, wdBtn, htBtn
  m_btnBuildOneBMPID = 101 
  oNMD.AddButton "Build Faction Images", margin+Btnspace*1, btnline1, wdBtn, htBtn
  m_btnBuildOneImageID = 102    
  oNMD.AddButton "Build Faction Frames", margin+Btnspace*2, btnline1, wdBtn, htBtn
  m_btnBuildOneFrameID = 103    
  oNMD.AddButton "Build Faction BIFs", margin+Btnspace*3, btnline1, wdBtn, htBtn
  m_btnBuildOneBIFID = 104 

  oNMD.AddButton "BUILD FACTION", margin+Btnspace*4, btnline1, wdBtn, htBtn
  m_btnBuildOneSpareID = 105  
 
  oNMD.AddButton "Build All BMPs", margin, btnline2, wdBtn, htBtn
  m_btnBuildAllBMPID = 106 
  oNMD.AddButton "Build All Images", margin+Btnspace*1, btnline2, wdBtn, htBtn
  m_btnBuildAllImageID = 107  
  oNMD.AddButton "Build All Frames", margin+Btnspace*2, btnline2, wdBtn, htBtn
  m_btnBuildAllFrameID = 108    
  oNMD.AddButton "Build All BIFs", margin+Btnspace*3, btnline2, wdBtn, htBtn
  m_btnBuildAllBIFID = 109 

  oNMD.AddButton "BUILD ALL", margin+Btnspace*4, btnline2, wdBtn, htBtn
  m_btnBuildAllSpareID = 110   

  oNMD.AddButton "Generate PROD11", margin, btnline3, wdBtn, htBtn
  m_btnGenProd11ID = 111   
  oNMD.AddButton "Generate DeadPage", margin+Btnspace, btnline3, wdBtn, htBtn
  m_btnGenDeadPageID = 112 
  
  oNMD.frmDialog.vbLine 20,htForm-10, 300,0 
 
  oNMD.AddButton "Cancel", Int((wdForm-wdBtn)/2), btnline4, wdBtn, htBtn
  m_btnCancelID = 113 
  oNMD.ShowDialog True
End Sub 


' ********************************************************************
' ********************************************************************
' ***
' *** All the subroutines follow from this point -
' ***
' ********************************************************************
' ********************************************************************


    
' *************************************************
' ***
' *** Confirmation routines
' ***
' *************************************************


Sub ConfirmCancel()
  If (Msgbox("Do you really want to cancel UM processing of """ & SelectionName & """?", _ 
     vbYesNo, "UM - Cancel") = vbYes) Then
    Wscript.Quit
  Else
    oNMDbCancelClick = False 
  End If
End Sub


Function ConfirmBuildAllBIF()
  If (Msgbox("Please confirm you want to build all BIFs (this may some time)?", _ 
     vbYesNo, "UM - Confirm ""Build All BIFs""") = vbYes) Then
    ConfirmBuildAllBIF = True
  Else
    ConfirmBuildAllBIF = False
  End If
End Function

    
Function ConfirmBuildAllBMP()
  If (Msgbox("Please confirm you want to build all BMPs (this may some time)?", _ 
     vbYesNo, "UM - Confirm ""Build All BMPs""") = vbYes) Then
    ConfirmBuildAllBMP = True
  Else
    ConfirmBuildAllBMP = False
  End If
End Function
    
' ********************************************************************
' ***
' *** Initialisation routines
' ***
' ********************************************************************

' ***
' *** 1st things 1st - get our (ie: this folders) path name
' *** and set the other paths
' ***
 
Sub GetOurPath() 

  RootPath = GetLocalDirectory() 

  SubPath = RootPath & "UMSubs\" 
  BRPath  = RootPath & "BifReader\" 

  Slogfilename = RootPath & "SessionLog.txt"
 
  IPcxPath = RootPath & "Input\UnitPCXs\" 
  IObjPath = RootPath & "Input\ObjectImages\"
  IPosPath = RootPath & "Input\ObjectPositions\"
  IPrmPath = RootPath & "Input\ParameterFiles\"
  IPicPath = RootPath & "Input\PictureImages\"
  IPicIPPath = RootPath & "Input\PictureImages\info_pics\"
  IPicRPPath = RootPath & "Input\PictureImages\review_panel\"
  IPicUIPath = RootPath & "Input\PictureImages\uniticons\"

  OBmpPath = RootPath & "Output\UnitBMPs\"
  OImgPath = RootPath & "Output\UnitImages\"
  OFrmPath = RootPath & "Output\UnitFrames\"
  OMTWPath = RootPath & "Output\MTWFiles\" 
  OObjPath = RootPath & "Output\ObjectImages\"  

  DefIPath = RootPath & "Defaults\DefImages\" 
  DefBPath = RootPath & "Defaults\DefBinaries\"   
  DefTPath = RootPath & "Defaults\DefTemplates\"
  DefPPath = RootPath & "Defaults\DefPositions\"
  DefFPath = RootPath & "Defaults\DefParameters\" 
 
End Sub


' ********************************************************************
' ***
' ***
' ***
' ********************************************************************

 
Sub GetSelectionName()
  Dim i, temp, selectionpath, optionlist
  SelectionName = ""

  Select Case UM   
    Case ID_BuildOne5Stages, ID_BuildAll5Stages 
      selectionpath = IPCXPath    
    Case ID_BuildOneBMP, ID_BuildAllBMP
      selectionpath = IPCXPath
    Case ID_BuildOneImage, ID_BuildAllImage 
      selectionpath = OBMPPath
    Case ID_BuildOneFrame, ID_BuildAllFrame 
      selectionpath = OImgPath 
    Case ID_BuildOneBIF, ID_BuildAllBIF 
      selectionpath = OFrmPath
    Case Else
  End Select

  Call BuildFactionList(selectionpath, optionlist)
  
  If (UM < 6) Then
    SelectionName = SelectFaction(optionlist)   
  Else
    SelectionName = """ALL"" factions"
  End If
 
End Sub


Sub BuildFactionList(inpath, optionlist)
  Dim onefolder, folder, temp, number 
  optionlist = ""  
  SelectionDic.RemoveAll
  TempDic.RemoveAll
  TempDicCnt = 0
  SelectionDicCnt = 0 
  number = 0
  Set onefolder = fso.GetFolder(inpath)
  For Each folder In onefolder.SubFolders
    temp = Split(folder, "\")      
    TempDicCnt = TempDicCnt + 1 
    TempDic.Add Cstr(TempDicCnt), temp(Ubound(temp))        
    SelectionDicCnt = SelectionDicCnt + 1
    SelectionDic.Add temp(Ubound(temp)), Dummy  
    number = number + 1
    Optionlist = Optionlist & number & " = " & temp(Ubound(temp)) & vbcrlf  
  Next
End Sub


Function SelectFaction(optionlist)
  Dim i, prompt, title, temp 
  Prompt = "Enter the number of the Faction you wish to process: " & vbcrlf & vbcrlf & OptionList
  Title = "UM - Select faction to process"
  temp = Cstr(Trim(InputBox (Prompt, Title)))
  SelectionDic.RemoveAll
  SelectionName = ""
  If (TempDic.Exists(temp)) Then   
    SelectionName = TempDic.Item(temp)
    SelectionDic.Add SelectionName, Dummy 
    SelectFaction = SelectionName 
  Else
    Call WriteSLMsg(0,"... invalid selection")
    SelectFaction = ""   
  End If
End Function


' ******************************************************************************** 
' ***
' *** Reads a text file into the array TxtFileArray
' *** 
' ******************************************************************************** 


Sub ReadTxtFile(filename)
  Dim i, line, linenum  
  Set MyFile = fso.OpenTextFile(filename, ForReading) 
  Redim TxtFileArray(0) 
  Redim TxtFileLineNum(0) 
  linenum = 0
  i = 0
  Do While Not MyFile.AtEndOfStream
    line = MyFile.ReadLine
    linenum = linenum + 1
    line = Replace(line, vbTab, OneSpace)
    While Instr(line, "  ")
      line = Replace(line, "  ", OneSpace)
    Wend
    If (line <> OneSpace) and (line <> "") Then 
      line = Trim(line)
      If Left(line, 2) <> "//" Then     ' ignore comments  
        Redim Preserve TxtFileArray(i+1) 
        TxtFileArray(i) = line
        Redim Preserve TxtFileLineNum(i+1) 
        TxtFileLineNum(i) = linenum
        i = i + 1
      End If
    End If 
  Loop  
  MyFile.Close 
End Sub 

' ***
' *** Reads a text file (completely) into the array TxtFileArray
' *** 

Sub ReadAllTxtFile(filename)
  Dim i, line, temp  
  Set MyFile = fso.OpenTextFile(filename, ForReading) 
  Redim TxtFileArray(0) 
  i = 0
  Do While Not MyFile.AtEndOfStream
    line = MyFile.ReadLine    
    Redim Preserve TxtFileArray(i+1) 
    TxtFileArray(i) = line
    i = i + 1   
  Loop  
  MyFile.Close 
End Sub 

' *************************************************
' ***
' *** RGB subs
' ***
' *************************************************

' ***
' *** Converts a numeric RGB string (format "26,176,228" - for example)
' *** into a hex RGB string (format "1AB0E4" - for example)
' *** Note: the hex RGB string format is required for the Graphics Imaging
' *** DLL/Package we are using (Trial version courtesy of ChestySoft)  
' ***

Function HexRGB(RGB)
  Dim temp, R, G, B 
  temp = Split(RGB, ",")
  If (Ubound(temp) <> 2) Then
   '  msgbox rgb 
  End If 
  temp(0) = Replace(temp(0), "(", "")
  temp(2) = Replace(temp(2), ")", "")
  R = Right("0" & Hex(temp(0)), 2)
  G = Right("0" & Hex(temp(1)), 2)
  B = Right("0" & Hex(temp(2)), 2)
  HexRGB = R & G & B
End Function

' ***
' *** Converts into a hex RGB string (format "1AB0E4" - for example)
' *** into a numeric RGB string (format "26,176,228" - for example)
' *** (the opposite of the function 'HexRGB' above)
' ***

Function DecRGB(RGB)
  Dim R, G, B  
  R = Int("&H" & Left(RGB, 2))
  G = Int("&H" & Mid(RGB, 3, 2))
  B = Int("&H" & Right(RGB, 2))
  DecRGB = R & "," & G & "," & B
End Function


' *************************************************
' ***
' *** RGB BIF conversions
' ***
' *************************************************

' ***
' *** Converts a numeric RGB string (format "26,176,228" - for example)
' *** into a hex RGB string for a bif colour palette (format "1AB0" - for example)
' ***

Function RGB2Bif(RGB)
  Dim v1,v2,v3, h1, h2, val1, val2, total, temp, n1, n2, n3
  Const Bits5 = 248          ' eg "11111000"
  Const Bits6 = 252          ' eg "11111100" 

  temp = Split(RGB, ",")
  n1 = temp(0)
  n2 = temp(1)
  n3 = temp(2)
  v1 = (n1 and Bits5) * 256
  v2 = (n2 and Bits6) * 8
  v3 = (n3 and Bits5) / 8
  total = v1 + v2 + v3
  val1 = (total and 65280) / 256 
  val2 = total and 255
  h1 = Right("0" & Hex(val1), 2)
  h2 = Right("0" & Hex(val2), 2)

  RGB2Bif = val1 & "," & val2 
End Function


' ***
' *** Converts a bif colour palette string (format "1AB0" - for example)
' *** into a numeric RGB string (format "26,176,228" - for example)
' *** (the opposite of the function 'RGB2Bif' above)
' ***

Function Bif2RGB(RGB)
  Dim v1,v2,v3, h1, h2, val1, val2, v2l, v2r
  Const Left5 = 248
  Const Right3 = 7
  Const Mid6 = 2016
  Const Right5 = 31
  Const Left3 = 224 
 
  val1 = Int("&H" & Right(RGB, 2))  
  val2 = Int("&H" & Left(RGB, 2))    
  v1 = (val1 and Left5)
  v2l = (val1 and Right3)
  v2r = (val2 and Left3)
  v2 = (v2l * 32) + (v2r / 8)
  v3 = (val2 and Right5) * 8
  Bif2RGB = v1 & "," & v2 & "," & v3  
End Function


' ****************************************************************************** 
' *** 
' *** Log file Routine 
' *** 
' ******************************************************************************


Sub WriteMsg(messageID, message)
  Dim MsgFile, msgID, timemsg
 
  Set MsgFile = Msgfso.OpenTextFile(Msgfilename, ForAppending, True)
  
  Select Case UM

    Case ID_BuildOneBMP
      message = "(OBMP)  " & message     
    Case ID_BuildOneBIF
      message = "(OBIF)  " & message     
    Case ID_BuildOne5Stages
      message = "(OPCX)  " & message     
    Case ID_BuildOneFrame
      message = "(OFrm)  " & message     

    Case ID_BuildAllBMP
      message = "(ABMP)  " & message     
    Case ID_BuildAllBIF
      message = "(ABIF)  " & message     
    Case ID_BuildAll5Stages
      message = "(APCX)  " & message     
    Case ID_BuildAllFrame
      message = "(AFrm)  " & message     


    Case ID_Backout
      message = "(B)  " & message   
    Case ID_Specials
      message = "(SP)  " & message   
   
    Case Else
  End Select   
  timemsg = Time & "  " & message
  msgID = Int(messageID)
  Select Case msgID
    Case 0
      MsgFile.Writeline timemsg
      oNMD.Addline timemsg 
    Case 1
      MsgFile.Writeline timemsg   
    Case Else
  End Select 
  
  MsgFile.Close 
End Sub


' ****************************************************************************** 
' *** 
' *** SessionLog file Routine 
' *** 
' ******************************************************************************


Sub WriteSLMsg(messageID, message)
  Dim SesFile, msgID, timemsg  
  Set SesFile = Msgfso.OpenTextFile(SLogfilename, ForAppending, True)
  
  Select Case UM

    Case ID_BuildOneBMP
      message = "(O-BMP)  " & message     
    Case ID_BuildOneBIF
      message = "(O-BIF)  " & message     
    Case ID_BuildOne5Stages
      message = "(O-All4)  " & message 
    Case ID_BuildOneImage
      message = "(O-Img)  " & message      
    Case ID_BuildOneFrame
      message = "(O-Frm)  " & message     

    Case ID_BuildAllBMP
      message = "(A-BMP)  " & message     
    Case ID_BuildAllBIF
      message = "(A-BIF)  " & message     
    Case ID_BuildAll5Stages
      message = "(A-All4)  " & message  
    Case ID_BuildAllImage
      message = "(A-Img)  " & message    
    Case ID_BuildAllFrame
      message = "(A-Frm)  " & message 
   
    Case Else
  End Select   

  timemsg = Time & "  " & message
  msgID = Int(messageID)
  Select Case msgID
    Case 0
      SesFile.Writeline timemsg
      oNMD.Addline timemsg 
    Case 1
      SesFile.Writeline timemsg      
    Case 2
      SesFile.Writeline message
    Case Else
  End Select 
  
  SesFile.Close 
End Sub


' ****************************************************************************** 
' *** 
' *** User Warning Routine 
' *** 
' ******************************************************************************

Sub WriteWarn(warnID, text)
  Dim WarnFile, line, colour, xypos  
  WrnCount = WrnCount + 1 

  If (warnings) Then

  Set WarnFile = Errfso.OpenTextFile(SLogfilename, ForAppending, True)       
    
  Select Case warnID     
    Case Warning_ShieldPosFileNotFound 
      line = "Warning: Shield positioning file (" & text & ") not found - using default"          
    Case Warning_WeaponPosFileNotFound 
      line = "Warning: Weapon positioning file (" & text & ") not found - using default"          
    
    Case Else
      line = "Error: INTERNAL ERROR. Invalid Warning number - " & warnID 
  End Select

  line = Time & "  " & line
  WarnFile.Writeline line
  oNMD.Addline line  
  
  WarnFile.Close  

  End If
End Sub


' ****************************************************************************** 
' *** 
' *** User Error Routine 
' *** 
' ******************************************************************************


Sub WriteErr(errorID, text)
  Dim ErrFile, line, a, b, colour, number, cnt   
  ErrCount = ErrCount + 1 
  
  Set ErrFile = Errfso.OpenTextFile(SLogfilename, ForAppending, True)       
   
  Select Case errorID

    Case Error_InvalidFactionFolder
      line = "Error: Invalid faction folder (""" & text & """) specified in " & CurrentFile 
    Case Error_InvalidBifName
      line = "Error: Invalid BIF name (""" & text & """) specified in " & CurrentFile 
    Case Error_FactionNotFound
      cnt = FactionBifDic.Count
      line = "Error: Faction (""" & text & """) not found in ""FactionBifDic"" (" & cnt & " entries)" 
    Case Error_InvalidAction
      line = "Error: Invalid action (""" & text & """) specified in " & CurrentFile  
    Case Error_FolderNotFound
      line = "Error: Invalid actions subfolder (""" & text & """) specified in " & CurrentFile  
    Case Error_DuplicateDicKey 
      line = "Error: Duplicate dictionary key - (""" & text & """)" 
    Case Error_InvalidKeyword 
      line = "Error: Invalid keyword (""" & text & """) specified in " & CurrentFile  
    Case Error_InvalidParameter
      line = "Error: Invalid parameter (""" & text & """) specified in " & CurrentFile 
    Case Error_UnknownCameraAngle 
      line = "Error: Unknown camera angle (""" & text & """)"  
    Case Error_BifNameSpecifiedTwice
      line = "Error: BIF name (""" & text & """) already specified in " & CurrentFile
    Case Error_UnitNameSpecifiedTwice
      line = "Error: Unit name (""" & text & """) already specified in " & CurrentFile
    Case Error_InvalidObjectSParameter
      line = "Error: ""Object="" shield parameters (""" & text & """) not 2"
    Case Error_InvalidObjectWParameter 
      line = "Error: ""Object="" weapon parameters (""" & text & """) not 4"
    Case Error_InvalidObjectSWParameter
      line = "Error: Unrecognised ""Object="" parameter (""" & text & """), must be S1-S5 or W1-W8" 
    Case Error_InvalidObjectSWNotFound
      line = "Error: ""Object="" weapon/sword (""" & text & """) image not found"  
    Case Error_ObjectAlreadySpecified 
      line = "Error: ""Object="" parameter (""" & text & """) already specified in this BIF" 
    Case Error_ActionsParameterActionNotFound 
      line = "Error: ""Actions="" action parameter (""" & text & """) invalid" 
    Case Error_ActionsParameterIdentifierNotFound 
      line = "Error: ""Actions="" positions identifier parameter (""" & text & """) not specified in this BIF" 
    Case Error_PositionIDAlreadySpecified
      line = "Error: ""Positions="" identifier parameter (""" & text & """) already specified in this BIF" 
    Case Error_DuplicateCA
      line = "Error: Camera angle prefix """ & text & """ already specified in " & CurrentFile 
     
    Case Else
      line = "Error: INTERNAL ERROR. Invalid Error number - " & errorID 
  End Select 

  line = Time & "  " & line
  ErrFile.Writeline line
  oNMD.Addline line 
  ErrFile.Close
  
  If (OnErrorQuit) Then
    MsgBox "Error discovered and 'OnErrorQuit=YES' specified - UM terminating", vbOk, _ 
    "UM - Error" 
    Wscript.Quit
  End If   
 
End Sub

     
' ****************************************************************************** 
' *** 
' *** Other required subs 
' *** 
' ******************************************************************************
 
' ***
' *** Get our (ie: this folders!) pathname
' ***

Function GetLocalDirectory() 
  Const sMe = "[GetLocalDirectory], "
  Dim iFile  ' as integer
  ' find the LAST backslash...
  iFile = InStrRev(Wscript.ScriptFullName, "\")
  BugAssert (iFile > 0), sMe & " file path problem "  ' if backslash not found...
  ' get the path to this script...
  GetLocalDirectory = Left(Wscript.ScriptFullName, iFile)  ' path (inc "\")... 
End Function

' ***
' *** Instantiate Object
' ***

Sub Instantiate (oObject, sProgramID, sEventPrefix)
  Const sMe = "[sub Instantiate], "
  ' check variant sub-type parameters...
  BugAssert (VarType(sProgramID) = vbString), sME & "sProgramID must be a STRING!"
  BugAssert (VarType(sEventPrefix) = vbString), sME & "sEventPrefix must be a STRING!"
  On Error Resume Next  ' turn on error checking
  Set oObject = WScript.CreateObject(sProgramID, sEventPrefix)
    BugAssert (err.number = 0), sME & "This script requires: " & sProgramID & vbCrlf _
        & "     kindly INSTALL and REGISTER this ActX component... "
    On Error goto 0  ' turn off error checking...
End Sub

' ***
' *** for critical errors
' ***

Sub BugAssert (bTest, sErrMsg)
  If (bTest) then Exit Sub
  MsgBox "Error Detected by BugAssert: " & vbCr & vbCr & sErrMsg, vbCritical, _ 
  " << BugAssert FAILED >> "
  WScript.Quit
End Sub

' ***
' *** for debugging
' ***

Sub ShowDic(thisdic, title)          ' debugging - display built dictionary
  Dim i, a1, a2, a3
  a1 = thisdic.Keys 
  a2 = thisdic.Items
  For i = 0 To thisdic.Count -1 ' Iterate the array.
    a3 = a3  & a1(i) & "  " & a2(i) & vbcrlf
  Next
  Wscript.echo title,vbcrlf,a3
End Sub


' ***
' *** for debugging
' ***

Sub WriteDic(thisdic, title)          ' debugging - display built dictionary
  Dim i, a1, a2, line
  a1 = thisdic.Keys 
  a2 = thisdic.Items
  For i = 0 To thisdic.Count -1 ' Iterate the array.
    line = "Dictionary """ & title & """ - " & a1(i) & " " & a2(i)  
    Call WriteSLMsg(0,"... *TESTMODE* " & line & " *TESTMODE*")
  Next  
End Sub


' ***
' *** for debugging
' ***

Sub ShowArray(thisarray, title)          ' debugging - display built dictionary
  Dim i, a1
  For i = 0 To Ubound(thisarray) -1 ' Iterate the array.
    a1 = a1  & thisarray(i) & vbcrlf
  Next
  Wscript.echo title,vbcrlf,a1
End Sub

Sub ShowArray256(thisarray, title)          ' debugging - display built dictionary
  Dim i, j, k, a1
  k = 0
  For i = 1 to 16
    a1 = ""
    For j = 1 to 16
      a1 = a1 & right("         " & thisarray(k), 8)
      k = k + 1 
    Next
    a1 = a1 & vbcrlf
  Next
  Wscript.echo title,vbcrlf,a1
End Sub


' ***
' *** Execute Global
' ***

Sub EGSubroutine(program)
  Dim UMsub, UMsubfile 
  Set UMsubfile = fso.OpenTextFile(SubPath & program)
  UMsub = UMsubfile.ReadAll
  UMsubfile.Close  
  ExecuteGlobal UMsub
End Sub


' *************************************************************************************
' *** 
' *** Sort routines
' ***
' *************************************************************************************

Function QuickSort(strAr, nSize, bAscending)
  Dim rc, low, high
  rc = True
  If (nSize > 1) Then
    low = 0
    high = nSize  
    QuickSortRecursive strAr,low,high,bAscending
  Else
    rc = False
  End If
  QuickSort =  rc
End Function


Function QuickSortRecursive(strAr, d, h, bAscending)
  Dim i, j, str, zal
  i = h
  j = d
  str = strAr(((d+h) / 2))
  Do
    If (bAscending) Then
      While (strAr(j) < str)
        j = j + 1
      Wend
      While (strAr(i) > str)
        i = i - 1
      Wend
    Else
      While (strAr(j) > str) j = j + 1
      Wend
      While (strAr(i) < str) i = i - 1
      Wend
    End If
    If ( i >= j ) Then
      If ( i <> j ) Then
        zal = strAr(i)
        strAr(i) = strAr(j)
        strAr(j) = zal
      End If
      i = i - 1
      j = j + 1
    End If
  Loop While (j <= i)
 
  If (d < i) Then
    QuickSortRecursive strAr,d,i,bAscending
  End If
 
  If (j < h) Then
    QuickSortRecursive strAr,j,h,bAscending
  End If
End Function


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build all folders in a path
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub BuildAllFolders(inpath, writemsg)
  Dim i, temp, mf, f1, nf, mfsf, pathname, oldpathname, foldername

  oldpathname = RootPath
  temp = Split(inpath, "\")

  For i = 0 to Ubound(temp)
    foldername = temp(i) 
    pathname = oldpathname & "\" & foldername  
    If (Not fso.FolderExists(pathname)) Then
      If (writemsg) Then
        Call WriteSLMsg(0,"... creating folder - """ & pathname & """ ...")  
      End If
      Set mf = fso.GetFolder(oldpathname)
      Set mfsf = mf.SubFolders   
      Set nf = mfsf.Add(foldername)  
    End If
    oldpathname = pathname
  Next

End Sub


' ****************************************************************************** 
' ****************************************************************************** 
' *** 
' *** Build a path/file Xref
' *** 
' ****************************************************************************** 
' ****************************************************************************** 


Sub WritePathXref(fromdic, tofile, topath)
  Dim i, line, filename, Dickeys, Dicitems, dickey, dicitem

  Call WriteSLMsg(0,"... writing """ & tofile & """ file ...")  

  filename = topath & "\" & tofile
  If (fso.FileExists(filename)) Then
    fso.DeleteFile(filename)
  End If
  
  Set MyFile = fso.OpenTextFile(filename, ForAppending, True)
 
  Dickeys  = fromdic.Keys 
  Dicitems = fromdic.Items   
  For i = 0 To fromdic.Count -1   
    dickey  = Dickeys(i)
    dicitem = Dicitems(i)   
    line = dickey  
    MyFile.Writeline line
  Next

  MyFile.Close 
  Set MyFile = Nothing  
  
End Sub 


